﻿機能設定:
	;-------------------------------------- 既に設定画面を開いているときは何もしない
	If (ExistConfigPanel == 1) {
		Return
	}Else{
		ExistConfigPanel := 1
	}
	;-------------------------------------- 画面を新規作成する
	GuiTitle := "機能設定"
	Gui,1: New,, %GuiTitle%
	Gui,1: Font, s11
	;=========================================== 現在の設定値を読み込む
	;------------------------------- ログオン時に起動する
	IniRead,StartUpChk,%IniFileName%,STARTUP,StartUp,0
	;------------------------------- モード切替通知
	If (OnChangeModeToolTip == 1) {
		ToolTipdsbl := 0
	}Else{
		ToolTipdsbl := 1
	}
	;=========================================== フォントの設定
	Gui,1: Font, s11
	;=========================================== タブ
	;Gui,1: Add, Tab2, h700 w780 vConfigTab, 機能設定|特殊設定
	Gui,1: Add, Tab2, h490 w500 vConfigTab, 履歴|通知音|ツールチップ|オプション機能|ホットキー|特殊設定
	If (TargetConfigTab == -1) {
		GuiControl, Choose, ConfigTab, 1
	}Else{
		GuiControl, ChooseString, ConfigTab, %TargetConfigTab%
	}
	;=========================================== クリップボード履歴
	Gui,1: Add, GroupBox, x22 y39 w370 h90 , クリップボード履歴
	Gui,1: Add, Text, x42 y59 w94 h20 , 履歴保管数
	Gui,1: Add, Edit, x172 y59 w54 h20 Number vMaxHistory, 
	Gui,1: Add, UpDown, x212 y59 w20 h20 , %MaxHistory%
	Gui,1: Add, Text, x42 y79 w130 h20 , 履歴保管時間（分）
	Gui,1: Add, Edit, x172 y79 w54 h20 Number vKeepMin, 
	Gui,1: Add, UpDown, x212 y79 w20 h20 , %KeepMin%
	Gui,1: Add, Text, x42 y99 w120 h20 , 履歴メニュー文字数
	Gui,1: Add, Edit, x172 y99 w54 h20 Number vMenuTextLen, 
	Gui,1: Add, UpDown, x212 y99 w20 h20 , %MenuTextLen%
	;=========================================== 履歴保存済みテキストをコピーした時の処理
	Gui,1: Add, GroupBox, x22 y139 w370 h90 , 履歴保存済みテキストをコピーした時の履歴への保存
	Gui,1: Add, Radio, x52 y159 w280 h20 vWhenCopySameText1, 常に保存する
	Gui,1: Add, Radio, x52 y179 w280 h20 vWhenCopySameText2, 直前の履歴と同じ時だけ保存しない
	Gui,1: Add, Radio, x52 y199 w280 h20 vWhenCopySameText3, 常に保存しない
	If (WhenCopySameText == 1) {
		GuiControl, ,WhenCopySameText1, 1
	}
	If (WhenCopySameText == 2) {
		GuiControl, ,WhenCopySameText2, 1
	}
	If (WhenCopySameText == 3) {
		GuiControl, ,WhenCopySameText3, 1
	}
	;=========================================== 次のタブ
	Gui, Tab, 2
	;=========================================== 通知音
	Gui,1: Add, GroupBox, x22 y39 w370 h190 , 通知音
	Gui,1: Add, ListView, x37 y59 w200 h155 NoSortHdr Grid -Multi AltSubmit Checked vSoundActNameLV gOnActionSoundActNameLV, 操作
	Gui,1: Add, Radio, x245 y59 w130 h20 Checked0 Disabled1 vSelectSoundBeep gSelectSoundBeep, BEEP音
	Gui,1: Add, Radio, x245 y79 w110 h20 Checked0 Disabled1 vSelectSoundFile gSelectSoundFile, サウンドファイル
	Gui,1: Add, Text, x265 y99 w120 h20 vSoundFileName,
	Gui,1: Add, Button, x265 y122 w80 h30 Disabled1 vSoundFileBtn gSoundFileBtn, 参照
	Gui,1: Add, Button, x265 y154 w80 h30 Disabled1 vSoundPlayBtn gSoundPlayBtn, 再生
	;-------------------------------------- 通知音リストビューを処理対象に変更する
	Gui,1: ListView,SoundActNameLV
	;-------------------------------------- 通知音リストビューを構築する
	LV_Add("Check"%OnChangeModeBeep%, "FIFO操作")
	LV_Add("Check"%OnCopyBeep%, "コピー（履歴重複なし）")
	LV_Add("Check"%OnCopyRepeatBeep%, "コピー（履歴重複あり）")
	LV_Add("Check"%OnPasteBeep%, "各種ペースト")
	LV_Add("Check"%OnWebSearchBeep%, "WEB検索")
	;--------------- リストビューの列幅を調整する
	LV_ModifyCol(1)
	;=========================================== 次のタブ
	Gui, Tab, 3
	;=========================================== ツールチップ
	Gui,1: Add, GroupBox, x22 y39 w370 h190 , ツールチップ
	Gui,1: Add, ListView, x37 y59 w200 h155 NoSortHdr Grid -Multi AltSubmit Checked vToolTipActNameLV gOnActionToolTipActNameLV, 操作
	Gui,1: Add, Text, x245 y59 w200 h30 , 表示時間（ミリ秒）
	Gui,1: Add, Edit, x289 y79 w54 h20 Number Disabled%ToolTipdsbl% vOnChangeModeToolTipDspTime, 
	Gui,1: Add, UpDown, x343 y79 w18 h20 Range500-1000, %OnChangeModeToolTipDspTime%
	;-------------------------------------- ツールチップリストビューを処理対象に変更する
	Gui,1: ListView,ToolTipActNameLV
	;-------------------------------------- 通知音リストビューを構築する
	LV_Add("Check"%OnChangeModeToolTip%, "FIFO操作")
	LV_Add("Check"%OnCopyToolTip%, "コピー（履歴重複なし）")
	LV_Add("Check"%OnCopyRepeatToolTip%, "コピー（履歴重複あり）")
	LV_Add("Check"%OnPasteToolTip%, "各種ペースト")
	LV_Add("Check"%OnWebSearchToolTip%, "WEB検索")
	;--------------- リストビューの列幅を調整する
	LV_ModifyCol(1)
	;=========================================== 次のタブ
	Gui, Tab, 4
	;=========================================== オプション機能
	Gui,1: Add, GroupBox, x22 y39 w370 h200 , オプション機能
	Gui,1: Add, ListView, x37 y59 w200 h155 NoSortHdr Grid -Multi AltSubmit Checked vOptionLV gOnActionOptionLV, オプション機能名
	Gui,1: Add, Button, x245 y59 w40 h30 Disabled1 vOptionUp gOptionUp, ↑
	Gui,1: Add, Button, x245 y92 w40 h30 Disabled1 vOptionDown gOptionDown, ↓
	Gui,1: Add, Button, x245 y184 w110 h30 Disabled1 vOptionConfig gOptionConfig, 設定
	Gui,1: Add, CheckBox, x42 y216 w210 h30 Checked%SplitMenu% vSplitMenu, オプション機能はメニューを分ける
	;-------------------------------------- オプション機能リストビューを処理対象に変更する
	Gui,1: ListView,OptionLV
	;-------------------------------------- オプション機能情報を取得しリストビューに追加する
	For index, OptOdr in OptionOrder {
		Chk := UseOption[OptOdr]
		LV_Add("Check"%Chk%, OptionName[OptOdr])
	}
	;-------------------------------------- オプション表示順を退避する
	OptionOrderMem := Object()
	For index, OptOdr in OptionOrder {
		OptionOrderMem[index] := OptionOrder[index]
	}
	;=========================================== 次のタブ
	Gui, Tab, 5
	;=========================================== ホットキー
	Gui,1: Add, GroupBox, x22 y39 w470 h440 , ホットキー
	Gui,1: Add, ListView, x37 y69 w430 h150 NoSortHdr Grid -Multi AltSubmit vHotkeyLV gOnActionHotkeyLV, 機能|ホットキー
	;-------------------------------------- 画面表示用のホットキー情報保管用の配列を定義する
	Global HK_HotkeyKeyboadMem := Object()
	Global HK_HotkeyMenuModifierMem := Object()
	Global HK_HotkeyMenuAssignMem := Object()
	;-------------------------------------- ホットキーリストビューを処理対象に変更する
	Sleep 100
	Gui,1: ListView,HotkeyLV
	IniRead,FirstRun,%IniFileName%,AUTOEXEC,StartUp,-1
	HotkeyCtr := 0
	;-------------------------------------- 割り当て可能なホットキーの数を取得する
	IniRead,HotkeyCount,%ConfigFileName%,HOTKEY,HotkeyCount,0
	If (FirstRun == -1) {
		;--------------- 初回起動時はiniファイルを自動作成する
		Filecopy,%A_ScriptDir%\config\default.ini,%IniFileName%
		;-------------------------------------- 初回起動時はデフォルト設定を表示する
		Loop {
			;--------------- 設定ファイルからホットキールーチン情報を読み込む
			KeyNo := A_Index
			Key = HotkeyName%KeyNo%
			IniRead,HotkeyName,%ConfigFileName%,HOTKEY,%Key%,-1
			If (HotkeyName == -1) {
				Break
			}
			Key = DefaultHotkey%KeyNo%
			IniRead,DefaultHotkey,%ConfigFileName%,HOTKEY,%Key%,-1
			;--------------- 実行用ホットキーを表示用ホットキーに変換する
			strWrk := DecodeHotkey(DefaultHotkey)
			;--------------- リストビューに追加する
			LV_Add("", HotkeyName, strWrk)
			;--------------- ホットキー追加用のドロップダウンリストの項目を設定する
			If (A_Index <= HotkeyCount) {
				If (A_Index == 1) {
					HotkeyNameDDL = %HotkeyName%
				}Else{
					HotkeyNameDDL = %HotkeyNameDDL%|%HotkeyName%
				}
			}
			;-------------------------------------- 「キーボードからホットキーを入力」を変数に保存する
			HotkeyCtr += 1
			HK_HotkeyKeyboadMem[HotkeyCtr] := DefaultHotkey
			;-------------------------------------- 「メニューからホットキーのキーを選択」を変数に保存する
			HK_HotkeyMenuAssignMem[HotkeyCtr] := ""
			;-------------------------------------- 「メニューからホットキーの修飾キーを選択」を変数に保存する
			HK_HotkeyMenuModifierMem[HotkeyCtr] := ""
		}
		;--------------- 設定を保存する
		Gosub ConfigOK
	}Else{
		;-------------------------------------- ホットキー情報を取得しリストビューに追加する
		Loop {
			;--------------- 設定ファイルからホットキールーチン情報を読み込む
			KeyNo := A_Index
			Key = HotkeyName%KeyNo%
			IniRead,HotkeyName,%ConfigFileName%,HOTKEY,%Key%,-1
			If (HotkeyName == -1) {
				Break
			}
			;--------------- ホットキー追加用のドロップダウンリストの項目を設定する
			If (A_Index <= HotkeyCount) {
				If (A_Index == 1) {
					HotkeyNameDDL = %HotkeyName%
				}Else{
					HotkeyNameDDL = %HotkeyNameDDL%|%HotkeyName%
				}
			}
			Loop {
				;--------------- iniファイルからホットキー情報を読み込む
				Key = Hotkey%KeyNo%_%A_Index%
				IniRead,strWrk,%IniFileName%,HOTKEY,%Key%,-1
				If (strWrk == -1) {
					Break
				}
				;--------------- 実行用ホットキーを表示用ホットキーに変換する
				strWrk := DecodeHotkey(strWrk)
				;--------------- リストビューに追加する
				LV_Add("", HotkeyName, strWrk)
				;--------------- 「キーボードからホットキーを入力」を変数に保存する
				HotkeyCtr += 1
				IniRead, strWrk, %IniFileName%, HOTKEY, HotkeyKeyboad%KeyNo%_%A_Index%, -1
				HK_HotkeyKeyboadMem[HotkeyCtr] := strWrk
				;--------------- 「メニューからホットキーのキーを選択」を変数に保存する
				IniRead, strWrk, %IniFileName%, HOTKEY, HotkeyMenuAssign%KeyNo%_%A_Index%, -1
				HK_HotkeyMenuAssignMem[HotkeyCtr] := strWrk
				;--------------- 「メニューからホットキーの修飾キーを選択」を変数に保存する
				IniRead, strWrk, %IniFileName%, HOTKEY, HotkeyMenuModifier%KeyNo%_%A_Index%, -1
				HK_HotkeyMenuModifierMem[HotkeyCtr] := strWrk
			}
		}
	}
	;--------------- リストビューの列幅を調整する
	LV_ModifyCol(1)
	LV_ModifyCol(2)
	Gui,1: Add, Button, x372 y229 w80 h30 Disabled1 vDeleteHotkeyBtn gDeleteHotkeyBtn, 削除
	Gui,1: Add, GroupBox, x37 y259 w430 h170 , ホットキーの割り当て
	Gui,1: Add, DropDownList, x52 y289 w310 h999 vAddHotkeyName gAddHotkeyName, %HotkeyNameDDL%
	Gui,1: Add, Radio, x52 y329 w130 h20 Disabled1 vSetByKeyboard gSetByKeyboard, キーボードから入力
	Gui,1: Add, Radio, x52 y359 w120 h20 Disabled1 vSelectByMenu gSelectByMenu, メニューから選択
	Gui,1: Add, Hotkey, x192 y329 w170 h20 Disabled1 vAddHotkey gAddHotkey, 
	Gui,1: Add, DropDownList, x192 y359 w170 h999 Disabled1 vAddkey gAddkey, %HotkeyAssignDDL%
	Gui,1: Add, DropDownList, x192 y389 w170 h999 Disabled1 vAddModifierKey gAddModifierKey, %ModifierDDL%
	Gui,1: Add, Button, x372 y356 w80 h30 Disabled1 gAddHotkeyBtn vAddHotkeyBtn, 追加
	Gui,1: Add, Button, x372 y386 w80 h30 Disabled1 gModifyHotkeyBtn vModifyHotkeyBtn, 変更
	Gui,1: Add, Text, x42 y442 w200 h30 , キー連打間隔（ミリ秒）
	Gui,1: Add, Edit, x182 y439 w50 h20 Number vKeyDoubleSens, 
	Gui,1: Add, UpDown, x212 y439 w18 h20 Range500-1000, %KeyDoubleSens%
	;=========================================== 次のタブ
	Gui, Tab, 6
	;=========================================== 改行文字
	Gui,1: Add, GroupBox, x22 y39 w470 h90 , 特殊文字
	Gui,1: Add, CheckBox, x42 y62 w150 h30 vChangeLineField gOnChangeLineField, 特殊文字を変更する
	Gui,1: Add, Text, x202 y69 w30 h20 , LF
	Gui,1: Add, Edit, x222 y69 w100 h20 Disabled1 vChrLF, %ChrLF%
	Gui,1: Add, Text, x202 y99 w30 h20 , CR
	Gui,1: Add, Edit, x222 y99 w100 h20 Disabled1 vChrCR, %ChrCR%
	Gui,1: Add, Text, x332 y69 w30 h20 , TAB
	Gui,1: Add, Edit, x362 y69 w100 h20 Disabled1 vChrTab, %ChrTab%
	;=========================================== ログオン時に起動する
	Gui,1: Add, CheckBox, x42 y134 w240 h30 Checked%StartUpChk% vStartUpChk, 自動起動（スタートアップに登録）する
	;=========================================== タブ外
	Gui, Tab
	;=========================================== 確定ボタン
	Gui,1: Add, Button, x280 y505 w100 h30 gConfigOK, 保存
	Gui,1: Add, Button, x390 y505 w100 h30 gConfigClose, 閉じる
	;Gui,1: Add, Button, x662 y579 w100 h30 gConfigCancel, キャンセル
	;=========================================== 画面表示
	Gui,1: Show, h544 w524, 機能設定
Return
;=========================================== モード切替時にツールチップを表示するチェックボタンをクリックしたときの処理
OnChangeModeToolTip:
	Gui,1: Submit ,NoHide
	GuiControl, Enable%OnChangeModeToolTip%, OnChangeModeToolTipDspTime
Return
;=========================================== 通知音リストビュー項目が選択されたときの処理
OnActionSoundActNameLV:
	;-------------------------------------- リストビューがフォーカスを受け取ったときは、処理対象のリストビューを変更する
	If (A_GuiEvent == "F" || A_GuiEvent == "Normal") {
		Gui, 1: ListView, SoundActNameLV
	}
	;-------------------------------------- リストビューの選択状態が変化したときは、リストビューにフォーカスをあわせる（ここでフォーカスをあててないと次にリストビューの項目をクリックしたときに正しくイベントが受け取れないため）
	If (A_GuiEvent == "I") {		
		GuiControl, Focus, SoundActNameLV
		Return
	}
	;------------------------------ 選択されている行の行番号を取得する
	SelectedRow := LV_GetNext(0)
	;------------------------------ 項目が埋まっている行がクリックされたときだけ処理する
	If (A_GuiEvent == "Normal") {
		If (SelectedRow > 0) {
			;-------------------------------------- コントロールを制御する
			GuiControl, Enable1, SelectSoundBeep
			GuiControl, Enable1, SelectSoundFile
			;-------------------------------------- FIFO操作が選択されたときの処理
			If (SelectedRow == 1) {
				;-------------------------------------- 選択した操作の設定をコントロールに反映する
				GuiControl, , SelectSoundBeep, 0
				GuiControl, , SelectSoundFile, 0
				;-------------------------------------- BEEP音が選択されている時の処理
				If (OnChangeModeSound == 1) {
					GuiControl, , SelectSoundBeep, 1
				}Else{
					GuiControl, , SelectSoundBeep, 0
				}
				;-------------------------------------- サウンドファイルが選択されている時の処理
				IF (OnChangeModeSound == 2) {
					GuiControl, , SelectSoundFile, 1
					SplitPath, OnChangeModeSoundFile, strWrk
					GuiControl, Text, SoundFileName, %strWrk%
				}Else{
					GuiControl, , SelectSoundFile, 0
				}
				;-------------------------------------- リストビューの選択行を保管
				SoundActNameLVSelectedRow := 1
			}
			;-------------------------------------- コピー操作（履歴重複なし）が選択されたときの処理
			If (SelectedRow == 2) {
				;-------------------------------------- 選択した操作の設定をコントロールに反映する
				GuiControl, , SelectSoundBeep, 0
				GuiControl, , SelectSoundFile, 0
				;-------------------------------------- BEEP音が選択されている時の処理
				If (OnCopySound == 1) {
					GuiControl, , SelectSoundBeep, 1
				}Else{
					GuiControl, , SelectSoundBeep, 0
				}
				;-------------------------------------- サウンドファイルが選択されている時の処理
				IF (OnCopySound == 2) {
					GuiControl, , SelectSoundFile, 1
					SplitPath, OnCopySoundFile, strWrk
					GuiControl, Text, SoundFileName, %strWrk%
				}Else{
					GuiControl, , SelectSoundFile, 0
				}
				;-------------------------------------- リストビューの選択行を保管
				SoundActNameLVSelectedRow := 2
			}
			;-------------------------------------- コピー操作（履歴重複あり）が選択されたときの処理
			If (SelectedRow == 3) {
				;-------------------------------------- 選択した操作の設定をコントロールに反映する
				GuiControl, , SelectSoundBeep, 0
				GuiControl, , SelectSoundFile, 0
				;-------------------------------------- BEEP音が選択されている時の処理
				If (OnCopyRepeatSound == 1) {
					GuiControl, , SelectSoundBeep, 1
				}Else{
					GuiControl, , SelectSoundBeep, 0
				}
				;-------------------------------------- サウンドファイルが選択されている時の処理
				IF (OnCopyRepeatSound == 2) {
					GuiControl, , SelectSoundFile, 1
					SplitPath, OnCopyRepeatSoundFile, strWrk
					GuiControl, Text, SoundFileName, %strWrk%
				}Else{
					GuiControl, , SelectSoundFile, 0
				}
				;-------------------------------------- リストビューの選択行を保管
				SoundActNameLVSelectedRow := 3
			}
			;-------------------------------------- 各種ペースト操作が選択されたときの処理
			If (SelectedRow == 4) {
				;-------------------------------------- 選択した操作の設定をコントロールに反映する
				GuiControl, , SelectSoundBeep, 0
				GuiControl, , SelectSoundFile, 0
				;-------------------------------------- BEEP音が選択されている時の処理
				If (OnPasteSound == 1) {
					GuiControl, , SelectSoundBeep, 1
				}Else{
					GuiControl, , SelectSoundBeep, 0
				}
				;-------------------------------------- サウンドファイルが選択されている時の処理
				IF (OnPasteSound == 2) {
					GuiControl, , SelectSoundFile, 1
					SplitPath, OnPasteSoundFile, strWrk
					GuiControl, Text, SoundFileName, %strWrk%
				}Else{
					GuiControl, , SelectSoundFile, 0
				}
				;-------------------------------------- リストビューの選択行を保管
				SoundActNameLVSelectedRow := 4
			}
			;-------------------------------------- WEB検索操作が選択されたときの処理
			If (SelectedRow == 5) {
				;-------------------------------------- 選択した操作の設定をコントロールに反映する
				GuiControl, , SelectSoundBeep, 0
				GuiControl, , SelectSoundFile, 0
				;-------------------------------------- BEEP音が選択されている時の処理
				If (OnWebSearchSound == 1) {
					GuiControl, , SelectSoundBeep, 1
				}Else{
					GuiControl, , SelectSoundBeep, 0
				}
				;-------------------------------------- サウンドファイルが選択されている時の処理
				IF (OnWebSearchSound == 2) {
					GuiControl, , SelectSoundFile, 1
					SplitPath, OnWebSearchSoundFile, strWrk
					GuiControl, Text, SoundFileName, %strWrk%
				}Else{
					GuiControl, , SelectSoundFile, 0
				}
				;-------------------------------------- リストビューの選択行を保管
				SoundActNameLVSelectedRow := 5
			}
			;-------------------------------------- サウンドファイルコントロールを制御する
			GuiControlGet, strWrk ,, SelectSoundFile
			If (strWrk == 1) {
				GuiControl, Enable1, SoundFileBtn
				GuiControl, Enable1, SoundPlayBtn
			}Else{
				GuiControl, Enable0, SoundFileBtn
				GuiControl, Enable0, SoundPlayBtn			
			}
		}Else{
			;-------------------------------------- コントロールを無効にする
			GuiControl, Enable0, SelectSoundBeep
			GuiControl, Enable0, SelectSoundFile
			GuiControl, Enable0, SoundFileBtn
			GuiControl, Enable0, SoundPlayBtn
		}
	}
Return
;=========================================== BEEP音を選択した時の処理
SelectSoundBeep:
	Gui,1: Submit ,NoHide
	;-------------------------------------- FIFO操作が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 1) {
		OnChangeModeSound := 1
		GuiControl, Text, SoundFileName, 
	}
	;-------------------------------------- コピー操作（履歴重複なし）が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 2) {
		OnCopySound := 1
		GuiControl, Text, SoundFileName, 
	}
	;-------------------------------------- コピー操作（履歴重複あり）が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 3) {
		OnCopyRepeatSound := 1
		GuiControl, Text, SoundFileName, 
	}
	;-------------------------------------- 各種ペースト操作が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 4) {
		OnPasteSound := 1
		GuiControl, Text, SoundFileName, 
	}
	;-------------------------------------- WEB検索操作が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 5) {
		OnWebSearchSound := 1
		GuiControl, Text, SoundFileName, 
	}
	;-------------------------------------- サウンドファイルコントロールを制御する
	GuiControl, Enable0, SoundFileBtn
	GuiControl, Enable0, SoundPlayBtn
Return
;=========================================== サウンドファイルを選択した時の処理
SelectSoundFile:
	Gui,1: Submit ,NoHide
	;-------------------------------------- FIFO操作が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 1) {
		OnChangeModeSound := 2
		SplitPath, OnChangeModeSoundFile, strWrk
		GuiControl, Text, SoundFileName, %strWrk%
	}
	;-------------------------------------- コピー操作（履歴重複なし）が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 2) {
		OnCopySound := 2
		SplitPath, OnCopySoundFile, strWrk
		GuiControl, Text, SoundFileName, %strWrk%
	}
	;-------------------------------------- コピー操作（履歴重複あり）が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 3) {
		OnCopyRepeatSound := 2
		SplitPath, OnCopyRepeatSoundFile, strWrk
		GuiControl, Text, SoundFileName, %strWrk%
	}
	;-------------------------------------- 各種ペースト操作が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 4) {
		OnPasteSound := 2
		SplitPath, OnPasteSoundFile, strWrk
		GuiControl, Text, SoundFileName, %strWrk%
	}
	;-------------------------------------- WEB検索操作が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 5) {
		OnWebSearchSound := 2
		SplitPath, OnWebSearchSoundFile, strWrk
		GuiControl, Text, SoundFileName, %strWrk%
	}
	;-------------------------------------- サウンドファイルコントロールを制御する
	GuiControl, Enable1, SoundFileBtn
	GuiControl, Enable1, SoundPlayBtn
Return
;=========================================== サウンドファイル参照ボタンをクリックした時の処理
SoundFileBtn:
	Gui,1: Submit ,NoHide
	;-------------------------------------- ファイル選択ダイアログを表示する
	FileSelectFile, strFileName, , %SoundFilePath%, サウンドファイルの参照
	If (strLen(strFileName) > 0) {
		;-------------------------------------- FIFO操作が選択されていたときの処理
		If (SoundActNameLVSelectedRow == 1) {
			OnChangeModeSoundFile = %strFileName%
		}
		;-------------------------------------- コピー操作（履歴重複なし）が選択されていたときの処理
		If (SoundActNameLVSelectedRow == 2) {
			OnCopySoundFile = %strFileName%
		}
		;-------------------------------------- コピー操作（履歴重複あり）が選択されていたときの処理
		If (SoundActNameLVSelectedRow == 3) {
			OnCopyRepeatSoundFile = %strFileName%
		}
		;-------------------------------------- 各種ペースト操作が選択されていたときの処理
		If (SoundActNameLVSelectedRow == 4) {
			OnPasteSoundFile = %strFileName%
		}
		;-------------------------------------- WEB検索操作が選択されていたときの処理
		If (SoundActNameLVSelectedRow == 5) {
			OnWebSearchSoundFile = %strFileName%
		}
		SplitPath, strFileName, strWrk
		GuiControl, Text, SoundFileName, %strWrk%
		;-------------------------------------- サウンドファイルコントロールを制御する
		GuiControl, Enable1, SoundPlayBtnReturn
	}
Return
;=========================================== サウンドファイル再生ボタンをクリックした時の処理
SoundPlayBtn:
	;-------------------------------------- FIFO操作が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 1) {
		SoundPlay, %OnChangeModeSoundFile%
	}
	;-------------------------------------- コピー操作（履歴重複なし）が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 2) {
		SoundPlay, %OnCopySoundFile%
	}
	;-------------------------------------- コピー操作（履歴重複あり）が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 3) {
		SoundPlay, %OnCopyRepeatSoundFile%
	}
	;-------------------------------------- 各種ペースト操作が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 4) {
		SoundPlay, %OnPasteSoundFile%
	}
	;-------------------------------------- WEB検索操作が選択されていたときの処理
	If (SoundActNameLVSelectedRow == 5) {
		SoundPlay, %OnWebSearchSoundFile%
	}
Return
OnActionToolTipActNameLV:
Return
;=========================================== オプション機能リストビュー項目が選択されたときの処理
OnActionOptionLV:
	;-------------------------------------- リストビューがフォーカスを受け取ったときは、処理対象のリストビューを変更する
	If (A_GuiEvent == "F" || A_GuiEvent == "Normal") {
		Gui, 1: ListView, OptionLV
	}
	;-------------------------------------- リストビューの選択状態が変化したときは、リストビューにフォーカスをあわせる（ここでフォーカスをあててないと次にリストビューの項目をクリックしたときに正しくイベントが受け取れないため）
	If (A_GuiEvent == "I") {		
		GuiControl, Focus, OptionLV
		Return
	}
	;------------------------------ 選択されている行の行番号を取得する
	SelectedRow := LV_GetNext(0)
	;------------------------------ 項目が埋まっている行がクリックされたときだけ処理する
	If (A_GuiEvent == "Normal") {
		If (SelectedRow > 0) {
			;-------------------------------------- ボタンが押せるようにする
			GuiControl, Enable1, OptionUp
			GuiControl, Enable1, OptionDown
			GuiControl, Enable1, OptionConfig
		}Else{
			;-------------------------------------- ボタンが押せないようにする
			GuiControl, Enable0, OptionUp
			GuiControl, Enable0, OptionDown
			GuiControl, Enable0, OptionConfig
		}
	}
Return
;=========================================== オプション機能の↑ボタンを押したときの処理
OptionUp:
	;-------------------------------------- 選択されている行を上げる
	OptionUpDown("Up")
Return
;=========================================== オプション機能の↓ボタンを押したときの処理
OptionDown:
	;-------------------------------------- 選択されている行を下げる
	OptionUpDown("Down")
Return
;=========================================== オプション機能のリストビュー項目を上下する
OptionUpDown(UpDown) {
	;-------------------------------------- オプション機能リストビューを処理対象に変更する
	Gui,1:ListView,OptionLV
	;-------------------------------------- 選択されている行の番号を取得する
	SelectedRow := LV_GetNext(0)
	If (UpDown == "Up") {
		If (SelectedRow > 1) {
			AltRow := SelectedRow - 1
		}Else{
			AltRow := 0
		}
	}Else{
		If (SelectedRow < LV_GetCount()) {
			AltRow := SelectedRow + 1
		}Else{
			AltRow := 0
		}
	}
	If (AltRow > 0) {
		;-------------------------------------- リストビューから表示を取得し配列に保存する
		UseOptionMem := Object()
		LV_Count := LV_GetCount()
		Loop %LV_Count% {
			ix := A_Index - 1
			If (LV_GetNext(ix, "C") == A_Index) {
				UseOptionMem[A_Index] := 1
			}Else{
				UseOptionMem[A_Index] := 0
			}
		}
		;-------------------------------------- 順番を変更する
		Wrk := UseOptionMem[AltRow]
		UseOptionMem[AltRow] := UseOptionMem[SelectedRow]
		UseOptionMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := OptionOrder[AltRow]
		OptionOrder[AltRow] := OptionOrder[SelectedRow]
		OptionOrder[SelectedRow] := Wrk
		;-------------------------------------- リストビューをいったん削除する
		LV_Delete()
		;-------------------------------------- リストビューを再構築する
		For index, OptOdr in OptionOrder {
			Chk := UseOption[OptOdr]
			LV_Add("Check"UseOptionMem[A_Index], OptionName[OptOdr])
		}
		;-------------------------------------- 移動した行を選択する
		LV_Modify(AltRow,"Select Vis")
	}
}
;=========================================== オプション機能の設定ボタンを押したときの処理
OptionConfig:
	;-------------------------------------- オプション機能リストビューを処理対象に変更する
	Gui,1:ListView,OptionLV
	;-------------------------------------- 選択されている行の番号を取得する
	SelectedRow := LV_GetNext(0)
	;-------------------------------------- 選択したオプション機能の設定画面を表示する
	LV_GetText(SelectedOptionName, SelectedRow, 1)
	Gosub %SelectedOptionName%機能設定
Return
;=========================================== ホットキーのリストビュー項目が選択されたときの処理
OnActionHotkeyLV:
	;-------------------------------------- リストビューがフォーカスを受け取ったときは、処理対象のリストビューを変更する
	If (A_GuiEvent == "F" || A_GuiEvent == "Normal") {
		Gui,1:ListView,HotkeyLV
	}
	;-------------------------------------- リストビューの選択状態が変化したときは、リストビューにフォーカスをあわせる（ここでフォーカスをあててないと次にリストビューの項目をクリックしたときに正しくイベントが受け取れないため）
	If (A_GuiEvent == "I") {		
		GuiControl, Focus, HotkeyLV
		Return
	}
	;------------------------------ 選択されている行の行番号を取得する
	SelectedRow := LV_GetNext(0)
	;------------------------------ 項目が埋まっている行がクリックされたときだけ処理する
	If (A_GuiEvent == "Normal") {
		If (SelectedRow > 0) {
			;-------------------------------------- ボタンを制御する
			GuiControl, Enable1, DeleteHotkeyBtn
			GuiControl, Enable0, AddHotkeyBtn
			GuiControl, Enable0, ModifyHotkeyBtn
			;-------------------------------------- ラジオボタンと登録フォームの内容をクリアする
			GuiControl, , SetByKeyboard, 0
			GuiControl, , SelectByMenu, 0
			GuiControl, , AddHotkey, 
			GuiControl, , Addkey, |%HotkeyAssignDDL%
			GuiControl, , AddModifierKey, |%ModifierDDL%
			;-------------------------------------- 「ホットキーを割り当てる機能名」ドロップダウンリストの該当項目を選択する
			LV_GetText(strWrk, SelectedRow, 1)
			GuiControl, Choose, AddHotkeyName, %strWrk%
			;-------------------------------------- 「キーボードからホットキーを入力」を画面に表示する
			strWrk := HK_HotkeyKeyboadMem[SelectedRow]
			If (StrLen(strWrk) > 0) {
				;-------------------------------------- ラジオボタンを押せるようにしてチェックする
				GuiControl, Enable1, SetByKeyboard
				GuiControl, Enable1, SelectByMenu
				GuiControl, , SetByKeyboard, 1
				;-------------------------------------- 登録フォームを操作できるようにしてホットキーの設定内容を画面に表示する
				GuiControl, Enable1, AddHotkey
				GuiControl, , AddHotkey, %strWrk%
			}
			;-------------------------------------- 「メニューからホットキーのキーを選択」を画面に表示する
			strWrk := HK_HotkeyMenuAssignMem[SelectedRow]
			If (StrLen(strWrk) > 0) {
				;-------------------------------------- ラジオボタンを押せるようにしてチェックする
				GuiControl, Enable1, SetByKeyboard
				GuiControl, Enable1, SelectByMenu
				GuiControl, , SelectByMenu, 1
				;-------------------------------------- 登録フォームを操作できるようにしてホットキーの設定内容を画面に表示する
				GuiControl, Enable1, Addkey
				GuiControl, Choose, Addkey, %strWrk%
			}
			;-------------------------------------- 表示したホットキーがコントロールキー連打のときは修飾キーを選択できないようにする
			strWrk := EncodeHotkey(strWrk)
			IfInString, strWrk, Dbl
			{
				;-------------------------------------- コントロールキー連打のときは修飾キーを選択できないようにする
				strWrk := HK_ModifierDsp[HotkeyModifierMaxCount]
				GuiControl, Choose, AddModifierKey, %strWrk%
				GuiControl, Enable0, AddModifierKey
			}Else{
				;-------------------------------------- ホットキーにマウスが選択されたときは修飾キーの内容を変更する
				IfInString, strWrk, Button
				{
					Gosub ChangeModifierForMouseDDL
				}
				IfInString, strWrk, Wheel
				{
					Gosub ChangeModifierForMouseDDL
				}
				;-------------------------------------- 「メニューからホットキーの修飾キーを選択」を画面に表示する
				strWrk := HK_HotkeyMenuModifierMem[SelectedRow]
				If (StrLen(strWrk) > 0) {
					;-------------------------------------- ラジオボタンを押せるようにしてチェックする
					GuiControl, Enable1, SelectByMenu
					GuiControl, , SelectByMenu, 1
					;-------------------------------------- 登録フォームを操作できるようにしてホットキーの設定内容を画面に表示する
					GuiControl, Enable1, AddModifierKey
					GuiControl, Choose, AddModifierKey, %strWrk%
				}
			}
		}Else{
			;--------------- 追加、変更ボタンが押せるか判定する
			Gosub IsEnableAddButton
			If (Rs == 0) {
				;--------------- 追加ボタンを押せるようにする
				GuiControl, Enable1, AddHotkeyBtn
			}Else{
				;--------------- 追加ボタンを押せないようにする
				GuiControl, Enable0, AddHotkeyBtn
			}
			;-------------------------------------- 削除ボタンを押せないようにする
			GuiControl, Enable0, DeleteHotkeyBtn
		}
	}
Return
;=========================================== ホットキーの削除ボタンを押したときの処理
DeleteHotkeyBtn:
	;-------------------------------------- ホットキーリストビューを処理対象に変更する
	Gui,1:ListView,HotkeyLV
	;-------------------------------------- 選択されている行番号を保管する
	ix := LV_GetNext(0)
	;-------------------------------------- 選択されている行を削除する（DeleteSelectedRow関数は定型文画面のスクリプトで定義）
	Rs := DeleteSelectedRow()
	If (Rs == 0) {
		;-------------------------------------- ホットキーの内容を入れ替える
		While ix < HotkeyCtr {
			HK_HotkeyKeyboadMem[ix] := HK_HotkeyKeyboadMem[ix + 1]
			HK_HotkeyMenuModifierMem[ix] := HK_HotkeyMenuModifierMem[ix + 1]
			HK_HotkeyMenuAssignMem[ix] := HK_HotkeyMenuAssignMem[ix + 1]
			ix += 1
		}
		HotkeyCtr -= 1
	}
Return
;=========================================== ホットキーの機能名称を選択した処理
AddHotkeyName:
	Gosub OnChangeHotkeyForm
	;-------------------------------------- ボタン等を制御する
	GuiControl, Enable1, SetByKeyboard
	GuiControl, Enable1, SelectByMenu
Return
;=========================================== ホットキーのキーボードから入力ラジオボタンを押したときの処理
SetByKeyboard:
	Gosub OnChangeHotkeyForm
	;-------------------------------------- ボタン等を制御する
	GuiControl, Enable1, AddHotkey
	GuiControl, Enable0, AddModifierKey
	GuiControl, Enable0, Addkey
Return
;=========================================== ホットキーのメニューから選択ラジオボタンを押したときの処理
SelectByMenu:
	GuiControl, Enable0, AddHotkey
	If (StrLen(AddModifierKey) > 0) {
		GuiControl, Enable1, AddModifierKey
	}Else{
		GuiControl, Enable0, AddModifierKey
	}
	GuiControl, Enable1, Addkey
	Gosub OnChangeHotkeyForm
Return
;=========================================== ホットキーを入力したときの処理
AddHotkey:
	Gosub OnChangeHotkeyForm
Return
;=========================================== ホットキーのキーを選択したときの処理
Addkey:
	Gui,1: Submit ,NoHide
	strWrk := EncodeHotkey(AddKey)
	;-------------------------------------- ドロップダウンリストの項目をリセットする
	GuiControl, , AddModifierKey, |%ModifierDDL%
	;-------------------------------------- ボタンを制御する
	GuiControl, Enable1, AddModifierKey
	GuiControl, Enable0, AddHotkeyBtn
	GuiControl, Enable0, ModifyHotkeyBtn
	IfInString, strWrk, Dbl
	{
		GuiControl, Enable1, AddHotkeyBtn
		;-------------------------------------- コントロールキー連打のときは修飾キーを選択できないようにする
		strWrk := HK_ModifierDsp[HotkeyModifierMaxCount]
		GuiControl, Choose, AddModifierKey, %strWrk%
		GuiControl, Enable0, AddModifierKey
	}Else{
		GuiControl, Enable1, AddModifierKey
	}
	;-------------------------------------- ホットキーにマウスが選択されたときは修飾キーの内容を変更する
	IfInString, strWrk, Button
	{
		Gosub ChangeModifierForMouseDDL
	}
	IfInString, strWrk, Wheel
	{
		Gosub ChangeModifierForMouseDDL
	}
	Gosub OnChangeHotkeyForm
Return
;=========================================== 修飾キーのドロップダウンリスト項目をマウス用に変更する
ChangeModifierForMouseDDL:
	GuiControl, , AddModifierKey, |%ModifierForMouseDDL%
Return
;=========================================== ホットキーの修飾キーを選択した時の処理
AddModifierKey:
	Gosub OnChangeHotkeyForm
Return
;=========================================== 入力フォームが変更されたときの処理
OnChangeHotkeyForm:
	Gui,1: Submit ,NoHide
	;-------------------------------------- リストビューを処理対象に変更する
	Gui,1:ListView,HotkeyLV
	SelectedRow := LV_GetNext(0)
	If (SelectedRow > 0) {
		GuiControlGet, strWrk , FocusV
		If (strWrk == "HotkeyLV") {
			;--------------- リストビューがアクティブになっているときは変更ボタンを押せないようにする
			GuiControl, Enable0, ModifyHotkeyBtn
		}Else{
			;--------------- 追加、変更ボタンが押せるか判定する
			Gosub IsEnableAddButton
			If (Rs == 0) {
				;--------------- 変更ボタンを押せるようにする
				GuiControl, Enable1, ModifyHotkeyBtn
			}Else{
				;--------------- 変更ボタンを押せないようにする
				GuiControl, Enable0, ModifyHotkeyBtn
			}
		}
	}Else{
		;--------------- 変更ボタンを押せないようにする
		GuiControl, Enable0, ModifyHotkeyBtn
	}
	;--------------- 追加、変更ボタンが押せるか判定する
	Gosub IsEnableAddButton
	If (Rs == 0) {
		GuiControl, Enable1, AddHotkeyBtn
	}Else{
		GuiControl, Enable0, AddHotkeyBtn
	}
Return
;=========================================== 追加、変更ボタンが押せるか判定する
IsEnableAddButton:
	Gui,1: Submit ,NoHide
	If (StrLen(AddHotkeyName) > 0) {
		If (SetByKeyboard == 1) {
			If (StrLen(AddHotkey) > 0) {
				Rs := 0
			}Else{
				Rs := -1
			}
		}Else{
			If (SelectByMenu == 1) {
				If (StrLen(Addkey) > 0 && StrLen(AddModifierKey) > 0) {
					Rs := 0
				}Else{
					Rs := -1
				}
			}Else{
				Rs := -1
			}
		}
	}Else{
		Rs := -1
	}
Return
;=========================================== ホットキーの追加ボタンを押したときの処理
AddHotkeyBtn:
	Mode := "Add"
	Gosub SendFormToHotkeyLV
Return
;=========================================== 変更ボタンが押されたときの処理
ModifyHotkeyBtn:
	Mode := "Mod"
	Gosub SendFormToHotkeyLV
Return
;=========================================== 入力フォームの内容をリストビューに転送する
SendFormToHotkeyLV:
	Gui,1: Submit ,NoHide
	;-------------------------------------- 処理対象のリストビューを変更する
	Gui,1:ListView,HotkeyLV
	;-------------------------------------- ホットキー保存用の添え字を設定する
	If (Mode == "Add") {
		HotkeyCtr += 1
		ix := HotkeyCtr
	}Else{
		SelectedRow := LV_GetNext(0)
		ix := SelectedRow
	}
	;-------------------------------------- ホットキーをリストビューに追加する
	If (SetByKeyboard == 1) {
		;--------------- 実行用ホットキーを表示用ホットキーに変換する
		strWrk := DecodeHotkey(AddHotkey)
		;-------------------------------------- ホットキーの内容を保存する
		HK_HotkeyKeyboadMem[ix] := AddHotkey
		HK_HotkeyMenuModifierMem[ix] := ""
		HK_HotkeyMenuAssignMem[ix] := ""
	}Else{
		If (AddModifierKey == HK_ModifierDsp[HotkeyModifierMaxCount] || StrLen(AddModifierKey) == 0) {
			;--------------- 修飾キーが指定されてないときはキーだけ登録する
			strWrk = %Addkey%
		}Else{
			strWrk = %AddModifierKey% + %Addkey%
		}
		;-------------------------------------- ホットキーの内容を保存する
		HK_HotkeyKeyboadMem[ix] := ""
		HK_HotkeyMenuModifierMem[ix] := AddModifierKey
		HK_HotkeyMenuAssignMem[ix] := Addkey
	}
	If (Mode == "Add") {
		;--------------------------------------リストビューに追加する
		LV_Add("", AddHotkeyName, strWrk)
	}Else{
		;--------------------------------------リストビューを変更する
		LV_Modify(SelectedRow, "Select", AddHotkeyName, strWrk)
	}
	;--------------- リストビューの列幅を調整する
	LV_ModifyCol(1,"AutoHdr")
	LV_ModifyCol(2,"AutoHdr")
Return
;=========================================== 改行文字を変更するチェックボタンをクリックしたときの処理
OnChangeLineField:
	Gui,1: Submit ,NoHide
	GuiControl, Enable%ChangeLineField%, ChrCR
	GuiControl, Enable%ChangeLineField%, ChrLF
	GuiControl, Enable%ChangeLineField%, ChrTab
Return
;=========================================== 保存ボタンを押したときの処理
ConfigOK:
	Gui,1: Submit ,NoHide
	;------------------------------------------- クリップボード履歴設定を保存する
	IniWrite,%MaxHistory%,%IniFileName%,HISTORY_CONFIG,MaxHistory
	IniWrite,%KeepMin%,%IniFileName%,HISTORY_CONFIG,KeepMin
	IniWrite,%MenuTextLen%,%IniFileName%,HISTORY_CONFIG,MenuTextLen
	;------------------------------------------- 履歴と同じテキストをコピーした時の処理をiniファイルに保存する
	GuiControlGet,strWork,,WhenCopySameText1
	If (strWork == 1) {
		WhenCopySameText := 1
	}
	GuiControlGet,strWork,,WhenCopySameText2
	If (strWork == 1) {
		WhenCopySameText := 2
	}
	GuiControlGet,strWork,,WhenCopySameText3
	If (strWork == 1) {
		WhenCopySameText := 3
	}
	IniWrite,%WhenCopySameText%,%IniFileName%,HISTORY_CONFIG,WhenCopySameText
	;------------------------------------------- 通知音リストビューのチェック有無を確認する
	;--------------- 処理対象のリストビューを変更する
	Gui,1: ListView,SoundActNameLV
	count := LV_GetCount()
	Loop %count%{
		;--------------- チェックが入っているか確認する
		ix := A_Index - 1
		CheckedNo := LV_GetNext(ix, "C")
		If (CheckedNo == A_Index) {
			Check := 1
		}Else{
			Check := 0
		}
		If (A_Index == 1) {
			OnChangeModeBeep := Check
		}
		If (A_Index == 2) {
			OnCopyBeep := Check
		}
		If (A_Index == 3) {
			OnCopyRepeatBeep := Check
		}
		If (A_Index == 4) {
			OnPasteBeep := Check
		}
		If (A_Index == 5) {
			OnWebSearchBeep := Check
		}
	}
	;------------------------------------------- ツールチップリストビューのチェック有無を確認する
	;--------------- 処理対象のリストビューを変更する
	Gui,1: ListView,ToolTipActNameLV
	count := LV_GetCount()
	Loop %count%{
		;--------------- チェックが入っているか確認する
		ix := A_Index - 1
		CheckedNo := LV_GetNext(ix, "C")
		If (CheckedNo == A_Index) {
			Check := 1
		}Else{
			Check := 0
		}
		If (A_Index == 1) {
			OnChangeModeToolTip := Check
		}
		If (A_Index == 2) {
			OnCopyToolTip := Check
		}
		If (A_Index == 3) {
			OnCopyRepeatToolTip := Check
		}
		If (A_Index == 4) {
			OnPasteToolTip := Check
		}
		If (A_Index == 5) {
			OnWebSearchToolTip := Check
		}
	}
	;------------------------------------------- FIFO操作通知設定を保存する
	IniWrite,%OnChangeModeBeep%,%IniFileName%,CHANGE_MODE_NOTIFY,OnChangeModeBeep
	IniWrite,%OnChangeModeSound%,%IniFileName%,CHANGE_MODE_NOTIFY,OnChangeModeSound
	IniWrite,%OnChangeModeSoundFile%,%IniFileName%,CHANGE_MODE_NOTIFY,OnChangeModeSoundFile
	IniWrite,%OnChangeModeToolTip%,%IniFileName%,CHANGE_MODE_NOTIFY,OnChangeModeToolTip
	;------------------------------------------- コピー操作（履歴重複なし）通知設定を保存する
	IniWrite,%OnCopyBeep%,%IniFileName%,CHANGE_MODE_NOTIFY,OnCopyBeep
	IniWrite,%OnCopySound%,%IniFileName%,CHANGE_MODE_NOTIFY,OnCopySound
	IniWrite,%OnCopySoundFile%,%IniFileName%,CHANGE_MODE_NOTIFY,OnCopySoundFile
	IniWrite,%OnCopyToolTip%,%IniFileName%,CHANGE_MODE_NOTIFY,OnCopyToolTip
	;------------------------------------------- コピー操作（履歴重複あり）通知設定を保存する
	IniWrite,%OnCopyRepeatBeep%,%IniFileName%,CHANGE_MODE_NOTIFY,OnCopyRepeatBeep
	IniWrite,%OnCopyRepeatSound%,%IniFileName%,CHANGE_MODE_NOTIFY,OnCopyRepeatSound
	IniWrite,%OnCopyRepeatSoundFile%,%IniFileName%,CHANGE_MODE_NOTIFY,OnCopyRepeatSoundFile
	IniWrite,%OnCopyRepeatToolTip%,%IniFileName%,CHANGE_MODE_NOTIFY,OnCopyRepeatToolTip
	;------------------------------------------- 各種ペースト操作通知設定を保存する
	IniWrite,%OnPasteBeep%,%IniFileName%,CHANGE_MODE_NOTIFY,OnPasteBeep
	IniWrite,%OnPasteSound%,%IniFileName%,CHANGE_MODE_NOTIFY,OnPasteSound
	IniWrite,%OnPasteSoundFile%,%IniFileName%,CHANGE_MODE_NOTIFY,OnPasteSoundFile
	IniWrite,%OnPasteToolTip%,%IniFileName%,CHANGE_MODE_NOTIFY,OnPasteToolTip
	;------------------------------------------- コピー操作通知設定を保存する
	IniWrite,%OnWebSearchBeep%,%IniFileName%,CHANGE_MODE_NOTIFY,OnWebSearchBeep
	IniWrite,%OnWebSearchSound%,%IniFileName%,CHANGE_MODE_NOTIFY,OnWebSearchSound
	IniWrite,%OnWebSearchSoundFile%,%IniFileName%,CHANGE_MODE_NOTIFY,OnWebSearchSoundFile
	IniWrite,%OnWebSearchToolTip%,%IniFileName%,CHANGE_MODE_NOTIFY,OnWebSearchToolTip
	;------------------------------------------- ツールチップ表示時間設定を保存する
	IniWrite,%OnChangeModeToolTipDspTime%,%IniFileName%,CHANGE_MODE_NOTIFY,OnChangeModeToolTipDspTime
	;------------------------------------------- オプション機能設定を保存する
	;--------------- 処理対象のリストビューを変更する
	Gui,1:ListView,OptionLV
	count := LV_GetCount()
	Loop %count%{
		OptOdr := OptionOrder[A_Index]
		;--------------- チェックが入っているか確認する
		ix := A_Index - 1
		CheckedNo := LV_GetNext(ix, "C")
		If (CheckedNo == A_Index) {
			Check := 1
		}Else{
			Check := 0
		}
		;--------------- オプション機能の使用有無を保存する
		Key = UseOption%OptOdr%
		IniWrite,%Check%,%IniFileName%,OPTION,%Key%
		;--------------- オプション機能メニューの表示順を保存する
		Key = OptionOrder%A_Index%
		IniWrite,%OptOdr%,%IniFileName%,OPTION,%Key%
	}
	;--------------- オプションメニューを分けるかどうかを保存する
	IniWrite,%SplitMenu%,%IniFileName%,OPTION,SplitMenu
	;------------------------------------------- ホットキーを保存する
	;--------------- 元の設定をいったん削除する
	IniDelete,%IniFileName%,HOTKEY
	IniDelete,%IniFileName%,PROTECT_HOTKEY1
	IniWrite,DMY,%IniFileName%,PROTECT_HOTKEY1,DMY
	;--------------- 処理対象のリストビューを変更する
	Gui,1:ListView,HotkeyLV
	;--------------- ホットキーカウンターを初期化する
	count := LV_GetCount()
	HK_Count := Object()
	Loop %count%{
		HK_Count[A_Index] := 0
	}
	;--------------- ホットキーが重複しているリストビューの行番号を保管する変数を初期化する
	HK_DuplicateRow := 0
	;--------------- 画面の内容で改めて保存する
	Loop %count%{
		;--------------- リストビューからホットキーに割り当てる機能名を取得する
		LV_GetText(HK_Name, A_Index , 1)
		Loop {
			;--------------- 取得した機能名のホットキー番号を取得し、その機能の個数をカウントする
			Key = HotkeyName%A_Index%
			IniRead,HotkeyName,%ConfigFileName%,HOTKEY,%Key%,-1
			If (HotkeyName == -1) {
				Break
			}
			If (HK_Name == HotkeyName) {
				HK_No := A_Index
				HK_Count[HK_No] += 1
				Break
			}
		}
		;--------------- リストビューからホットキー情報を取得する
		LV_GetText(HK_Key, A_Index , 2)
		;--------------- 表示用ホットキーを実行用ホットキーに変換する
		strWrk := EncodeHotkey(HK_Key)
		;--------------- ホットキーの重複をチェックする
		ix := 1
		TargetRow := A_Index
		Loop {
			ProtectSection = PROTECT_HOTKEY%ix%
			;--------------- プロテクトホットキーを保存するiniファイルのセクションが存在するか確認する
			IniRead,dmy,%IniFileName%,%ProtectSection%,DMY,-1
			If (dmy == -1) {
				Break
			}
			;--------------- 保存しようとしているホットキーがプロテクトされているか確認する
			IniRead,PHK_MenuName,%IniFileName%,%ProtectSection%,%strWrk%,0
			If (PHK_MenuName == 0 || PHK_MenuName == HK_Name) {
				HK_Duplicate := 0
			}Else{
				HK_Duplicate := 1
				HK_DuplicateRow := TargetRow
				HK_DuplicateMenuName := PHK_MenuName
				Break
			}
			ix += 1
		}
		If (HK_Duplicate == 0) {
			;--------------- ホットキーを保存する
			ix := HK_Count[HK_No]
			Key = Hotkey%HK_No%_%ix%
			IniWrite,%strWrk%,%IniFileName%,HOTKEY,%key%
			;--------------- 保存したホットキーをプロテクトする
			IniWrite,%HK_Name%,%IniFileName%,PROTECT_HOTKEY1,%strWrk%
			;-------------------------------------- 表示用ホットキーをiniファイルに保存する
			strWrk := HK_HotkeyKeyboadMem[A_Index]
			IniWrite,%strWrk%,%IniFileName%,HOTKEY,HotkeyKeyboad%HK_No%_%ix%
			strWrk := HK_HotkeyMenuAssignMem[A_Index]
			IniWrite,%strWrk%,%IniFileName%,HOTKEY,HotkeyMenuAssign%HK_No%_%ix%
			strWrk := HK_HotkeyMenuModifierMem[A_Index]
			IniWrite,%strWrk%,%IniFileName%,HOTKEY,HotkeyMenuModifier%HK_No%_%ix%
		}
	}
	;------------------------------------------- キー連打間隔を保存する
	IniWrite,%KeyDoubleSens%,%IniFileName%,DOUBLE_PUSH_HOTKEY,KeyDoubleSens
	;------------------------------------------- 改行文字を保存する
	IniWrite,%ChrLF%,%IniFileName%,LFCR,ChrLF
	IniWrite,%ChrCR%,%IniFileName%,LFCR,ChrCR
	IniWrite,%ChrTab%,%IniFileName%,LFCR,ChrTab
	;------------------------------------------- 自動起動設定を保存する
	IniWrite,%StartUpChk%,%IniFileName%,STARTUP,StartUp
	;------------------------------------------- スタートアップに登録する
	ScriptFileName = %A_ScriptDir%\%A_ScriptName%
	ShortCutFileName = %A_Startup%\ShowClip.lnk
	If (StartUpChk == 1) {
		FileCreateShortcut, %ScriptFileName%, %ShortCutFileName%, %A_ScriptDir%
	}Else{
		FileDelete, %ShortCutFileName%
	}
	;------------------------------------------- 退避したオプション表示順を更新する
	For index, OptOdr in OptionOrder {
		OptionOrderMem[index] := OptionOrder[index]
	}
	If (HK_DuplicateRow == 0) {
		If (FirstRun == -1) {
			;------------------------------------------- 初回起動時の設定保存処理の場合は、リロードせず設定画面を表示したままにする
			FirstRun := 0
		}Else{
			;------------------------------------------- リロード後、設定画面を再表示させるように設定する
			IniWrite,1,%IniFileName%,AUTOEXEC,StartUp
			IniWrite,機能設定,%IniFileName%,AUTOEXEC,ShowConfigPanel
			GuiControlGet, ActiveTabText, ,ConfigTab
			IniWrite,%ActiveTabText%,%IniFileName%,AUTOEXEC,TargetConfigTab
			;------------------------------------------- スクリプトをリロードして設定を反映させる
			Reload
		}
	}Else{
		LV_GetText(HK_DuplicateMenuText, HK_DuplicateRow , 1)
		LV_GetText(HK_DuplicateHotkey, HK_DuplicateRow , 2)
		LV_Modify(HK_DuplicateRow,"Select")
		MsgBox 「%HK_DuplicateMenuText%」に割当てようとしているホットキー「%HK_DuplicateHotkey%」は、すでに「%HK_DuplicateMenuName%」に割当てられています。
	}
Return
;=========================================== キャンセルボタンを押したときの処理
;ConfigCancel:
	;------------------------------------------- 退避したオプション表示順を更新する
	;For index, OptOdr in OptionOrder {
	;	OptionOrder[index] := OptionOrderMem[index]
	;}
	;Gui,1: Destroy
;Return
;=========================================== GUI画面を閉じたときの処理
ConfigClose:
GuiClose:
	;------------------------------------------- 退避したオプション表示順を復元する
	For index, OptOdr in OptionOrder {
		OptionOrder[index] := OptionOrderMem[index]
	}
	;------------------------------------------- 再表示指定をクリアする
	IniWrite,0,%IniFileName%,AUTOEXEC,StartUp
	IniWrite,%ActiveTabText%,%IniFileName%,AUTOEXEC,-1
	;------------------------------------------- スクリプトをリロードして設定を反映させる
	Reload
Return
;=========================================== 実行用ホットキーを表示用ホットキーに変換する
DecodeHotkey(HotkeyEnc) {
	;-------------------------------------- 修飾キーを表示用に変換する
	StringUpper, HotkeyEnc, HotkeyEnc
	RsHotkeyDsp := HotkeyEnc
	For index, HK_Enc in HK_ModifierEnc {
		If (StrLen(HK_Enc) > 0) {
			;--------------- 修飾キーが含まれるときだけ処理する
			IfInString, RsHotkeyDsp, %HK_Enc%
			{
				;--------------- 修飾キーの出現位置を取得する
				StringGetPos, DelimtPos, RsHotkeyDsp, %HK_Enc%
				;--------------- 修飾キーの位置でホットキーを左右に分割する
				StringLeft, strLeft, RsHotkeyDsp, DelimtPos
				StringMid, strRight, RsHotkeyDsp, DelimtPos + StrLen(HK_Enc) + 1
				;--------------- 表示用のホットキーを編集する
				HK_Dsp := HK_ModifierDsp[index] . " ＋ "
				RsHotkeyDsp = %strLeft%%HK_Dsp%%strRight%
			}
		}
	}
	StringReplace, RsHotkeyDsp, RsHotkeyDsp, ＋, +, All
	;-------------------------------------- キーを表示用に変換する
	For index, HK_Enc in HK_KeyAssignEnc {
		;--------------- 変換対象のキーが含まれるときだけ処理する
		IfInString, RsHotkeyDsp, %HK_Enc%
		{
			;--------------- 変換対象のキー出現位置を取得する
			StringGetPos, DelimtPos, RsHotkeyDsp, %HK_Enc%
			;--------------- 変換対象のキー位置でホットキーを左右に分割する
			StringLeft, strLeft, RsHotkeyDsp, DelimtPos
			StringMid, strRight, RsHotkeyDsp, DelimtPos + StrLen(HK_Enc) + 1
			;--------------- 表示用のホットキーを編集する
			HK_Dsp := HK_KeyAssignDsp[index]
			RsHotkeyDsp = %strLeft%%HK_Dsp%%strRight%
		}
	}
	Return RsHotkeyDsp
}
;=========================================== 表示用ホットキーを実行用ホットキーに変換する
EncodeHotkey(HotkeyDsp) {
	;-------------------------------------- 修飾キーを実行用に変換する
	RsHotkeyEnc := HotkeyDsp
	StringReplace, RsHotkeyEnc, RsHotkeyEnc, +, , All
	StringReplace, RsHotkeyEnc, RsHotkeyEnc, %A_Space%, , All
	For index, HK_Dsp in HK_ModifierDsp {
		;--------------- 修飾キーが含まれるときだけ処理する
		IfInString, RsHotkeyEnc, %HK_Dsp%
		{
			;--------------- 修飾キーの出現位置を取得する
			StringGetPos, DelimtPos, RsHotkeyEnc, %HK_Dsp%
			;--------------- 修飾キーの位置でホットキーを左右に分割する
			StringLeft, strLeft, RsHotkeyEnc, DelimtPos
			StringMid, strRight, RsHotkeyEnc, DelimtPos + StrLen(HK_Dsp) + 1
			;--------------- 表示用のホットキーを編集する
			HK_Enc := HK_ModifierEnc[index]
			RsHotkeyEnc = %strLeft%%HK_Enc%%strRight%
		}
	}
	;-------------------------------------- キーを実行用に変換する
	For index, HK_Dsp in HK_KeyAssignDsp {
		;--------------- 変換対象のキーが含まれるときだけ処理する
		IfInString, RsHotkeyEnc, %HK_Dsp%
		{
			;--------------- 変換対象のキー出現位置を取得する
			StringGetPos, DelimtPos, RsHotkeyEnc, %HK_Dsp%
			;--------------- 変換対象のキー位置でホットキーを左右に分割する
			StringLeft, strLeft, RsHotkeyEnc, DelimtPos
			StringMid, strRight, RsHotkeyEnc, DelimtPos + StrLen(HK_Dsp) + 1
			;--------------- 表示用のホットキーを編集する
			HK_Enc := HK_KeyAssignEnc[index]
			RsHotkeyEnc = %strLeft%%HK_Enc%%strRight%
		}
	}
	Return RsHotkeyEnc
}
