﻿選択文字でWEB検索機能設定:
	Gui,4: New
	;=========================================== 機能設定画面を操作不可にする
	Gui,1:Hide
	;-------------------------------------- 既に設定画面を開いているときは何もしない
	IfWinExist 選択文字でWEB検索機能設定
	{
		Return
	}
	;=========================================== フォントの設定
	Gui,4: Font, s11, 
	;=========================================== 選択文字でWEB検索機能リストビュー
	Gui,4: Add, GroupBox, x22 y19 w490 h420 , 登録内容
	Gui,4: Add, ListView, x42 y49 w450 h290 NoSortHdr Grid -Multi AltSubmit Checked vWebSearchLV gOnActionWebSearchLV, メニュー表示|ホットキー|検索モード|検索アドレス|末尾に追加する文字
	;--------------- 画面表示用のホットキー情報保管用の配列を定義する
	Global WS_HotkeyKeyboadMem := Object()
	Global WS_HotkeyMenuModifierMem := Object()
	Global WS_HotkeyMenuAssignMem := Object()
	;--------------- WEB検索機能の設定内容を読み込んでリストビューを構築する
	Gosub BuildWebSearchLV
	Gui,4: Add, Button, x52 y349 w40 h30 Disabled1 vWebSearchUpBtn gWebSearchUp, ↑
	Gui,4: Add, Button, x102 y349 w40 h30 Disabled1 vWebSearchDownBtn gWebSearchDown, ↓
	Gui,4: Add, Button, x412 y349 w70 h30 Disabled1 vWebSearchDeleteBtn gWebSearchDelete, 削除
	Gui,4: Add, Button, x252 y389 w230 h30 Disabled1 vWebSearchSaveBtn gOnClickWebSearchSaveBtn, 保存
	Gui,4: Add, Text, x532 y19 w100 h20 , メニュー表示
	Gui,4: Add, Edit, x542 y41 w340 h20 vWebSearchMenuText gOnChangeWebSearchMenuText,
	Gui,4: Add, Text, x532 y68 w100 h20 , 検索アドレス
	Gui,4: Add, Edit, x542 y89 w340 h20 vWebSearchURL gOnChangeWebSearchURL,
	Gui,4: Add, Text, x532 y117 w350 h20 , 検索ワード末尾に追加する文字
	Gui,4: Add, Edit, x542 y140 w340 h20 vWebSearchSuffix gOnChangeWebSerachSuffix,
	Gui,4: Add, CheckBox, x542 y164 w350 h30 vWebSearchMode gOnChangeWebSearchMode, 前回の検索ワードに追加して検索
	Gui,4: Add, GroupBox, x532 y199 w350 h190 , ホットキー
	Gui,4: Add, CheckBox, x552 y229 w200 h30 vWebSearchAssignHotkey gOnChangeWebSearchAssignHotkey, ホットキーを割り当てる
	Gui,4: Add, Radio, x552 y272 w130 h20 Disabled1 vWebSearchSetByKeyboard gWebSearchSetByKeyboard, キーボードから入力
	Gui,4: Add, Radio, x552 y309 w120 h20 Disabled1 vWebSearchSelectByMenu gWebSearchSelectByMenu, メニューから選択
	Gui,4: Add, Hotkey, x692 y272 w170 h20 Disabled1 vWebSearchAddHotkey gWebSearchAddHotkey, 
	Gui,4: Add, DropDownList, x692 y309	w170 h999 Disabled1 vWebSearchAddkey gWebSearchAddkey, %HotkeyAssignDDL%
	Gui,4: Add, DropDownList, x692 y349 w170 h999 Disabled1 vWebSearchAddModifierKey gWebSearchAddModifierKey, %ModifierDDL%
	Gui,4: Add, Button, x552 y409 w70 h30 Disabled1 vWebSearchClearBtn gOnClickWebSearchClearBtn, クリア
	Gui,4: Add, Button, x702 y409 w70 h30 Disabled1 vWebSearchAddBtn gOnClickWebSearchAddBtn, 追加
	Gui,4: Add, Button, x792 y409 w70 h30 Disabled1 vWebSearchModifyBtn gOnClickWebSearchModifyBtn, 変更
	;=========================================== 前回終了時に設定画面が表示されていた場合はリストビューの選択状態を復元する
	IniRead,strWrk,%IniFileName%,AUTOEXEC,StartUp,0
	If (strWrk == 1) {
		;--------------- 再表示指定をクリアする
		IniWrite,0,%IniFileName%,AUTOEXEC,StartUp
		;--------------- 選択文字でWEB検索機能リストビューの選択状態を復元する
		IniRead,strWrk,%IniFileName%,AUTOEXEC, WS_SelectedRow
		If (strWrk > 0) {
			Gui,4:ListView,WebSearchLV
			LV_Modify(strWrk, "Select")
			SelectedRow := strWrk
			Gosub ExpandWebSearch
		}
	}
	Gui,4: Add, Button, x779 y456 w100 h30 g4ConfigClose, 閉じる
	;=========================================== 画面表示
	Gui,4: Show, h503 w906, 選択文字でWEB検索機能設定
Return
;=========================================== リストビューが選択されたときの処理
OnActionWebSearchLV:
	;-------------------------------------- リストビューがフォーカスを受け取ったときは、処理対象のリストビューを変更する
	If (A_GuiEvent == "F" || A_GuiEvent == "Normal") {
		Gui, 4: ListView, WebSearchLV
	}
	;-------------------------------------- リストビューのチェックボックスがクリックされたときの処理
	If (A_GuiEvent == "I" && (InStr(ErrorLevel, "c") > 0 || InStr(ErrorLevel, "C") > 0)) {
		;-------------------------------------- 保存ボタンを押せるようにする
		GuiControl, Enable1, WebSearchSaveBtn
		;-------------------------------------- リストビューの選択状態が変化したときは、リストビューにフォーカスをあわせる（ここでフォーカスをあててないと次にリストビューの項目をクリックしたときに正しくイベントが受け取れないため）
		GuiControl, Focus, WebSearchLV
	}
	;------------------------------ 選択されている行の行番号を取得する
	SelectedRow := LV_GetNext(0)
	;------------------------------ 項目が埋まっている行がクリックされたときだけ処理する
	If (A_GuiEvent == "Normal" || (A_GuiEvent == "K" && (A_EventInfo == "38" || A_EventInfo == "40"))) {
		If (SelectedRow > 0) {
			;-------------------------------------- 選択された検索機能の登録内容を展開する
			Gosub ExpandWebSearch
		}Else{
			;-------------------------------------- ボタンを押せないようにする
			GuiControl, Enable0, WebSearchUpBtn
			GuiControl, Enable0, WebSearchDownBtn
			GuiControl, Enable0, WebSearchDeleteBtn
			GuiControl, Enable0, WebSearchModifyBtn
		}
	}
Return
;=========================================== 登録内容を展開する
ExpandWebSearch:
	IF (SelectedRow > 0) {
		;-------------------------------------- 処理が終わるまでリストビューを操作不可にする
		;GuiControl, Enable0, WebSearchLV
		;-------------------------------------- 入力フォームをクリアする
		Gosub OnClickWebSearchClearBtn
		LV_GetText(strWrk, SelectedRow, 1)
		If (strWrk != "メニュー表示") {
			;-------------------------------------- メニュー表示の設定内容を画面に表示する
			GuiControl, Text, WebSearchMenuText, %strWrk%
			SelectedWebSearchMenuText := strWrk
			;-------------------------------------- 検索アドレスの設定内容を画面に表示する
			LV_GetText(strWrk, SelectedRow, 4)
			GuiControl, Text, WebSearchUrl, %strWrk%
			;-------------------------------------- 検索ワード末尾に追加する文字の設定内容を画面に表示する
			LV_GetText(strWrk, SelectedRow, 5)
			GuiControl, Text, WebSearchSuffix, %strWrk%
			;-------------------------------------- 検索モードの設定内容を画面に表示する
			LV_GetText(strWrk, SelectedRow, 3)
			Key = Mode%strWrk%
			IniRead, strWrk, %ConfigFileName%, WEB_SEARCH_MODE, %Key%, -1
			GuiControl, , WebSearchMode, %strWrk%
			;-------------------------------------- ホットキーが設定されているか確認する
			LV_GetText(strWrk, SelectedRow, 2)
			If (StrLen(strWrk) > 0) {
				;-------------------------------------- チェックボックスをオンにする
				GuiControl, , WebSearchAssignHotkey, 1
				;-------------------------------------- ラジオボタンとホットキー登録フォームを操作できるようにする
				GuiControl, Enable1, WebSearchSetByKeyboard
				GuiControl, Enable1, WebSearchSelectByMenu
			}
			;-------------------------------------- リストビューのチェックボックスの状態を取得する
			ix := SelectedRow - 1
			If (LV_GetNext(ix, "C") == SelectedRow) {
				Mode := 1
			}Else{
				Mode := 0
			}
			;-------------------------------------- 「キーボードからホットキーを入力」を画面に表示する
			strWrk := WS_HotkeyKeyboadMem[SelectedRow]
			If (StrLen(strWrk) > 0) {
				;-------------------------------------- ラジオボタンを押せるようにしてチェックする
				GuiControl, Enable1, WebSearchSetByKeyboard
				GuiControl, , WebSearchSetByKeyboard, 1
				;-------------------------------------- 登録フォームを操作できるようにしてホットキーの設定内容を画面に表示する
				GuiControl, Enable1, WebSearchAddHotkey
				GuiControl, , WebSearchAddHotkey, %strWrk%
			}
			;-------------------------------------- 「メニューからホットキーのキーを選択」を画面に表示する
			strWrk := WS_HotkeyMenuAssignMem[SelectedRow]
			If (StrLen(strWrk) > 0) {
				;-------------------------------------- ラジオボタンを押せるようにしてチェックする
				GuiControl, Enable1, WebSearchSelectByMenu
				GuiControl, , WebSearchSelectByMenu, 1
				;-------------------------------------- 登録フォームを操作できるようにしてホットキーの設定内容を画面に表示する
				GuiControl, Enable1, WebSearchAddkey
				GuiControl, Choose, WebSearchAddkey, %strWrk%
			}
			;-------------------------------------- 表示したホットキーがコントロールキー連打のときは修飾キーを選択できないようにする
			strWrk := EncodeHotkey(strWrk)
			IfInString, strWrk, Dbl
			{
				;-------------------------------------- コントロールキー連打のときは修飾キーを選択できないようにする
				strWrk := HK_ModifierDsp[HotkeyModifierMaxCount]
				GuiControl, Choose, WebSearchAddModifierKey, %strWrk%
				GuiControl, Enable0, WebSearchAddModifierKey
			}Else{
				;-------------------------------------- ホットキーにマウスが選択されたときは修飾キーの内容を変更する
				IfInString, strWrk, Button
				{
					Gosub ChangeWebSearchModifierForMouseDDL
				}
				IfInString, strWrk, Wheel
				{
					Gosub ChangeWebSearchModifierForMouseDDL
				}
				;-------------------------------------- 「メニューからホットキーの修飾キーを選択」を画面に表示する
				strWrk := WS_HotkeyMenuModifierMem[SelectedRow]
				If (StrLen(strWrk) > 0) {
					;-------------------------------------- ラジオボタンを押せるようにしてチェックする
					GuiControl, Enable1, WebSearchSelectByMenu
					GuiControl, , WebSearchSelectByMenu, 1
					;-------------------------------------- 登録フォームを操作できるようにしてホットキーの設定内容を画面に表示する
					GuiControl, Enable1, WebSearchAddModifierKey
					GuiControl, Choose, WebSearchAddModifierKey, %strWrk%
				}
			}
			;-------------------------------------- ボタンを押せるようにする
			GuiControl, Enable1, WebSearchUpBtn
			GuiControl, Enable1, WebSearchDownBtn
			GuiControl, Enable1, WebSearchDeleteBtn
			;-------------------------------------- リストビューを操作可能に戻す
			;GuiControl, Enable1, WebSearchLV
		}
	}
Return
;=========================================== ↑ボタンを押したときの処理
WebSearchUp:
	;-------------------------------------- 選択されている行を上げる
	WebSearchUpDown("Up")
Return
;=========================================== ↓ボタンを押したときの処理
WebSearchDown:
	;-------------------------------------- 選択されている行を下げる
	WebSearchUpDown("Down")
;=========================================== リストビューの項目を上下する
WebSearchUpDown(UpDown) {
	;-------------------------------------- 選択されている行の番号を取得する
	SelectedRow := LV_GetNext(0)
	If (UpDown == "Up") {
		If (SelectedRow > 1) {
			AltRow := SelectedRow - 1
		}Else{
			AltRow := 0
		}
	}Else{
		If (SelectedRow < LV_GetCount()) {
			AltRow := SelectedRow + 1
		}Else{
			AltRow := 0
		}
	}
	If (AltRow > 0) {
		;-------------------------------------- リストビューから表示を取得し配列に保存する
		WebSearchEnableMem := Object()
		WebSearchMenuTextMem := Object()
		WebSearchHotkeyMem := Object()
		WebSearchModeMem := Object()
		WebSearchUrlMem := Object()
		WebSearchSuffixMem := Object()
		LV_Count := LV_GetCount()
		Loop %LV_Count% {
			;-------------------------------------- リストビューのチェックボックスの状態を取得する
			ix := A_Index - 1
			If (LV_GetNext(ix, "C") == A_Index) {
				WebSearchEnableMem[A_Index] := 1
			}Else{
				WebSearchEnableMem[A_Index] := 0
			}
			LV_GetText(strWrk, A_Index, 1)
			WebSearchMenuTextMem[A_Index] := strWrk
			LV_GetText(strWrk, A_Index, 2)
			WebSearchHotkeyMem[A_Index] := strWrk
			LV_GetText(strWrk, A_Index, 3)
			WebSearchModeMem[A_Index] := strWrk
			LV_GetText(strWrk, A_Index, 4)
			WebSearchUrlMem[A_Index] := strWrk
			LV_GetText(strWrk, A_Index, 5)
			WebSearchSuffixMem[A_Index] := strWrk
		}
		;-------------------------------------- 順番を変更する
		Wrk := WebSearchEnableMem[AltRow]
		WebSearchEnableMem[AltRow] := WebSearchEnableMem[SelectedRow]
		WebSearchEnableMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := WebSearchMenuTextMem[AltRow]
		WebSearchMenuTextMem[AltRow] := WebSearchMenuTextMem[SelectedRow]
		WebSearchMenuTextMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := WebSearchHotkeyMem[AltRow]
		WebSearchHotkeyMem[AltRow] := WebSearchHotkeyMem[SelectedRow]
		WebSearchHotkeyMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := WebSearchModeMem[AltRow]
		WebSearchModeMem[AltRow] := WebSearchModeMem[SelectedRow]
		WebSearchModeMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := WebSearchUrlMem[AltRow]
		WebSearchUrlMem[AltRow] := WebSearchUrlMem[SelectedRow]
		WebSearchUrlMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := WebSearchSuffixMem[AltRow]
		WebSearchSuffixMem[AltRow] := WebSearchSuffixMem[SelectedRow]
		WebSearchSuffixMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := WS_HotkeyKeyboadMem[AltRow]
		WS_HotkeyKeyboadMem[AltRow] := WS_HotkeyKeyboadMem[SelectedRow]
		WS_HotkeyKeyboadMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := WS_HotkeyMenuModifierMem[AltRow]
		WS_HotkeyMenuModifierMem[AltRow] := WS_HotkeyMenuModifierMem[SelectedRow]
		WS_HotkeyMenuModifierMem[SelectedRow] := Wrk
		;-------------------------------------- 順番を変更する
		Wrk := WS_HotkeyMenuAssignMem[AltRow]
		WS_HotkeyMenuAssignMem[AltRow] := WS_HotkeyMenuAssignMem[SelectedRow]
		WS_HotkeyMenuAssignMem[SelectedRow] := Wrk
		;-------------------------------------- リストビューをいったん削除する
		LV_Delete()
		;-------------------------------------- リストビューを再構築する
		loop %LV_Count% {
			LV_Add("Check"WebSearchEnableMem[A_Index], WebSearchMenuTextMem[A_Index], WebSearchHotkeyMem[A_Index], WebSearchModeMem[A_Index], WebSearchUrlMem[A_Index], WebSearchSuffixMem[A_Index])
		}
		;--------------- リストビューの列幅を調整する
		LV_ModifyCol(1,"AutoHdr")
		LV_ModifyCol(2,"AutoHdr")
		LV_ModifyCol(3,"AutoHdr")
		LV_ModifyCol(4,"AutoHdr")
		LV_ModifyCol(5,"AutoHdr")
		;-------------------------------------- 移動したグループを選択する
		LV_Modify(AltRow,"Select Vis")
		;-------------------------------------- 保存ボタンを押せるようにする
		GuiControl, Enable1, WebSearchSaveBtn
	}
}
Return
;=========================================== 削除ボタンを押したときの処理
WebSearchDelete:
	;-------------------------------------- 選択されている行番号を保管する
	ix := LV_GetNext(0)
	;-------------------------------------- 選択されている行を削除する（DeleteSelectedRow関数は定型文画面のスクリプトで定義）
	Rs := DeleteSelectedRow()
	If (Rs == 0) {
		;-------------------------------------- ホットキーの内容を入れ替える
		While ix < WebSearchCtr {
			WS_HotkeyKeyboadMem[ix] := WS_HotkeyKeyboadMem[ix + 1]
			WS_HotkeyMenuModifierMem[ix] := WS_HotkeyMenuModifierMem[ix + 1]
			WS_HotkeyMenuAssignMem[ix] := WS_HotkeyMenuAssignMem[ix + 1]
			ix += 1
		}
		WebSearchCtr -= 1
		;-------------------------------------- ボタンを制御する
		GuiControl, Enable1, WebSearchSaveBtn
		GuiControl, Enable0, WebSearchUpBtn
		GuiControl, Enable0, WebSearchDownBtn
		GuiControl, Enable0, WebSearchDeleteBtn
	}
Return
;=========================================== 保存ボタンを押したときの処理
OnClickWebSearchSaveBtn:
	;SplashImage,,B1 FM12 CWFFFFA2,,選択文字でWEB検索機能設定を保存しています
	;-------------------------------------- 元の設定をいったん削除する
	IniDelete,%IniFileName%,PROTECT_HOTKEY2
	IniWrite,DMY,%IniFileName%,PROTECT_HOTKEY2,DMY
	;-------------------------------------- リストビューを処理対象に変更する
	Gui,4:ListView,WebSearchLV
	;-------------------------------------- ホットキーカウンターを初期化する
	LV_Count := LV_GetCount()
	Ctr := Object()
	Ctr[0] := 0
	Ctr[1] := 0
	;-------------------------------------- ホットキーが重複しているリストビューの行番号を保管する変数を初期化する
	HK_DuplicateRow := 0
	Loop %LV_Count% {
		;-------------------------------------- リストビューのチェックボックスの状態を取得して保存するiniファイルのセクション番号を設定する
		;--------------- チェックが入っているか確認する
		ix := A_Index - 1
		CheckedNo := LV_GetNext(ix, "C")
		If (CheckedNo == A_Index) {
			Check := 1
		}Else{
			Check := 0
		}
		;--------------- セクション番号を設定する
		Ctr[Check] += 1
		strWrk := Ctr[Check]
		Section = WEB_SEARCH%Check%_%strWrk%
		;-------------------------------------- メニューテキストをiniファイルに保存する
		LV_GetText(MenuText, A_Index, 1)
		IniWrite,%MenuText%,%IniFileName%,%Section%,MenuText
		;-------------------------------------- 検索アドレスをiniファイルに保存する
		LV_GetText(strWrk, A_Index, 4)
		IniWrite,%strWrk%,%IniFileName%,%Section%,URL
		;-------------------------------------- 検索ワードに追加する文字をiniファイルに保存する
		LV_GetText(strWrk, A_Index, 5)
		IniWrite,%strWrk%,%IniFileName%,%Section%,Suffix
		;-------------------------------------- 検索モードをiniファイルに保存する
		LV_GetText(strWrk, A_Index, 3)
		;-------------------------------------- 実行用の検索モードを取得して保存する
		Key = Mode%strWrk%
		IniRead, strWrk, %ConfigFileName%, WEB_SEARCH_MODE, %Key%, -1
		IniWrite,%strWrk%,%IniFileName%,%Section%,Mode
		;-------------------------------------- ホットキーをiniファイルに保存する
		LV_GetText(strWrk, A_Index, 2)
		If (StrLen(strWrk) > 0) {
			;-------------------------------------- 表示用ホットキーを実行用ホットキーに変換する（関数は機能設定画面スクリプトで定義）
			strWrk := EncodeHotkey(strWrk)
			;-------------------------------------- ホットキーの重複をチェックする
			ix := 1
			TargetRow := A_Index
			Loop {
				ProtectSection = PROTECT_HOTKEY%ix%
				;--------------- プロテクトホットキーを保存するiniファイルのセクションが存在するか確認する
				IniRead,dmy,%IniFileName%,%ProtectSection%,DMY,-1
				If (dmy == -1) {
					Break
				}
				;--------------- 保存しようとしているホットキーがプロテクトされているか確認する
				IniRead,PHK_MenuName,%IniFileName%,%ProtectSection%,%strWrk%,0
				If (PHK_MenuName == 0 || PHK_MenuName == MenuText) {
					HK_Duplicate := 0
				}Else{
					HK_Duplicate := 1
					HK_DuplicateRow := TargetRow
					HK_DuplicateMenuName := PHK_MenuName
					Break
				}
				ix += 1
			}
			If (HK_Duplicate == 0) {
				;-------------------------------------- ホットキーを保存する
				IniWrite,%strWrk%,%IniFileName%,%Section%,Hotkey
				;-------------------------------------- 保存したホットキーをプロテクトする
				IniWrite,%MenuText%,%IniFileName%,PROTECT_HOTKEY2,%strWrk%
			}
		}Else{
			;-------------------------------------- ホットキーを保存する
			IniWrite,%strWrk%,%IniFileName%,%Section%,Hotkey
		}
		;-------------------------------------- 表示用ホットキーをiniファイルに保存する
		strWrk := WS_HotkeyKeyboadMem[A_Index]
		IniWrite,%strWrk%,%IniFileName%,%Section%,HotkeyKeyboad
		strWrk := WS_HotkeyMenuAssignMem[A_Index]
		IniWrite,%strWrk%,%IniFileName%,%Section%,HotkeyMenuAssign
		strWrk := WS_HotkeyMenuModifierMem[A_Index]
		IniWrite,%strWrk%,%IniFileName%,%Section%,HotkeyMenuModifier
	}
	;-------------------------------------- 不要なiniファイルの項目を削除する
	ix := Object()
	ix[0] := Ctr[0] + 1
	ix[1] := Ctr[1] + 1
	Loop 2 {
		S_No1 := A_Index - 1
		Loop {
			S_No2 := ix[S_No1]
			Section = WEB_SEARCH%S_No1%_%S_No2%
			IniRead, strWrk, %IniFileName%, %Section%, MenuText, -1
			If (strWrk == -1) {
				Break
			}
			IniDelete,%IniFileName%,%Section%
			ix[A_Index] += 1
		}
	}
	;-------------------------------------- スプラッシュ表示を消去する
	;SplashImage,off
	;MsgBox 選択文字でWEB検索機能設定を保存しました
	If (HK_DuplicateRow == 0) {
		;-------------------------------------- 再表示時に復元できるようにリストビューの選択状態を保存してリロードする
		Gosub SaveLastSessionAndReloadWS
	}Else{
		LV_GetText(HK_DuplicateMenuText, HK_DuplicateRow , 1)
		LV_GetText(HK_DuplicateHotkey, HK_DuplicateRow , 2)
		MsgBox 「%HK_DuplicateMenuText%」に割当てようとしているホットキー「%HK_DuplicateHotkey%」は、すでに「%HK_DuplicateMenuName%」に割当てられています。
		LV_Modify(HK_DuplicateRow,"Select")
	}
Return
;=========================================== 「メニュー表示」エディットボックスが入力されたときの処理
OnChangeWebSearchMenuText:
	Gosub OnChangeWebSearchForm
Return
;=========================================== 「検索URL」エディットボックスが入力されたときの処理
OnChangeWebSearchURL:
	Gosub OnChangeWebSearchForm
Return
;=========================================== 「検索ワード末尾に追加する文字」エディットボックスが入力されたときの処理
OnChangeWebSerachSuffix:
	Gosub OnChangeWebSearchForm
Return
;=========================================== 前回の検索ワードに追加して検索をチェックしたときの処理
OnChangeWebSearchMode:
	Gosub OnChangeWebSearchForm
Return
;=========================================== 「ホットキーを割り当てる」チェックボックスが押されたときの処理
OnChangeWebSearchAssignHotkey:
	Gosub OnChangeWebSearchForm
	If (WebSearchAssignHotkey == 1) {
		;-------------------------------------- ラジオボタン等を押せるようにする
		GuiControl, Enable1, WebSearchSetByKeyboard
		GuiControl, Enable1, WebSearchSelectByMenu
		If (WebSearchSetByKeyboard == 1) {
			GuiControl, Enable1, WebSearchAddHotkey
		}
		If (WebSearchSelectByMenu == 1) {
			GuiControl, Enable1, WebSearchAddModifierKey
			GuiControl, Enable1, WebSearchAddkey
		}
	}Else{
		;-------------------------------------- ラジオボタン等を押せないようにする
		GuiControl, Enable0, WebSearchSetByKeyboard
		GuiControl, Enable0, WebSearchSelectByMenu	
		GuiControl, Enable0, WebSearchAddHotkey
		GuiControl, Enable0, WebSearchAddModifierKey
		GuiControl, Enable0, WebSearchAddkey
	}
Return
;=========================================== 「キーボードから入力」ラジオボタンを押したときの処理
WebSearchSetByKeyboard:
	Gosub OnChangeWebSearchForm
	;-------------------------------------- ボタン等を制御する
	GuiControl, Enable1, WebSearchAddHotkey
	GuiControl, Enable0, WebSearchAddkey
	GuiControl, Enable0, WebSearchAddModifierKey
Return
;=========================================== 「メニューから選択」ラジオボタンを押したときの処理
WebSearchSelectByMenu:
	Gosub OnChangeWebSearchForm
	;-------------------------------------- ボタン等を制御する
	GuiControl, Enable0, WebSearchAddHotkey
	GuiControl, Enable0, WebSearchAddModifierKey
	GuiControl, Enable1, WebSearchAddkey
Return
;=========================================== ホットキーを入力したときの処理
WebSearchAddHotkey:
	Gosub OnChangeWebSearchForm
Return
;=========================================== ホットキーのキーを選択したときの処理
WebSearchAddkey:
	Gui,4: Submit ,NoHide
	GuiControl, , WebSearchAddModifierKey, |%ModifierDDL%
	GuiControl, Enable1, WebSearchAddModifierKey
	GuiControl, Enable0, WebSearchAddHotkeyButton
	strWrk := EncodeHotkey(WebSearchAddKey)
	IfInString, strWrk, Dbl
	{
		;-------------------------------------- コントロールキー連打のときは修飾キーを選択できないようにする
		strWrk := HK_ModifierDsp[HotkeyModifierMaxCount]
		GuiControl, Choose, WebSearchAddModifierKey, %strWrk%
		GuiControl, Enable0, WebSearchAddModifierKey
	}Else{
		GuiControl, Enable1, WebSearchAddModifierKey
	}
	;-------------------------------------- ホットキーにマウスが選択されたときは修飾キーの内容を変更する
	IfInString, strWrk, Button
	{
		Gosub ChangeWebSearchModifierForMouseDDL
	}
	IfInString, strWrk, Wheel
	{
		Gosub ChangeWebSearchModifierForMouseDDL
	}
	Gosub OnChangeWebSearchForm
Return
;=========================================== 修飾キーのドロップダウンリスト項目をマウス用に変更する
ChangeWebSearchModifierForMouseDDL:
	GuiControl, , WebSearchAddModifierKey, |%ModifierForMouseDDL%
Return
;=========================================== ホットキーの修飾キーを選択したときの処理
WebSearchAddModifierKey:
	Gosub OnChangeWebSearchForm
Return
;=========================================== 入力フォームが変更されたときの処理
OnChangeWebSearchForm:
	Gui,4: Submit ,NoHide
	;-------------------------------------- リストビューを処理対象に変更する
	Gui,4:ListView,WebSearchLV
	SelectedRow := LV_GetNext(0)
	If (SelectedRow > 0) {
		GuiControlGet, strWrk , FocusV
		If (strWrk == "WebSearchLV") {
			;--------------- リストビューがアクティブになっているときは変更ボタンを押せないようにする
			GuiControl, Enable0, WebSearchModifyBtn
		}Else{
			;--------------- 変更ボタンが押せるか判定する
			Gosub IsEnableWebSearchModifyButton
			If (Rs == 0) {
				;--------------- 変更ボタンを押せるようにする
				GuiControl, Enable1, WebSearchModifyBtn
			}Else{
				;--------------- 変更ボタンを押せないようにする
				GuiControl, Enable0, WebSearchModifyBtn
			}
		}
	}Else{
		;--------------- 変更ボタンを押せないようにする
		GuiControl, Enable0, WebSearchModifyBtn
	}
	;--------------- 追加ボタンが押せるか判定する
	Gosub IsEnableWebSearchAddButton
	If (Rs == 0) {
		GuiControl, Enable1, WebSearchAddBtn
	}Else{
		GuiControl, Enable0, WebSearchAddBtn
	}
	;--------------- クリアボタンが押せるか判定する
	Gosub IsEnableWebSearchClearButton
	If (Rs == 0) {
		GuiControl, Enable1, WebSearchClearBtn
	}Else{
		GuiControl, Enable0, WebSearchClearBtn
	}
Return
;=========================================== 追加ボタンが押せるか判定する
IsEnableWebSearchAddButton:
	Gui,4: Submit ,NoHide
	;--------------- メニュー表示と検索アドレスが入力されていて、メニュー表示がリストビューの選択されている内容と違う時だけ押せるようにする
	If (StrLen(WebSearchMenuText) > 0 && StrLen(WebSearchURL) > 0 && SelectedWebSearchMenuText <> WebSearchMenuText) {
		If (WebSearchAssignHotkey = 1) {
			If (WebSearchSetByKeyboard == 1) {
				If (StrLen(WebSearchAddHotkey) > 0) {
					Rs := 0
				}Else{
					Rs := -1
				}
			}Else{
				If (WebSearchSelectByMenu == 1) {
					If (StrLen(WebSearchAddkey) > 0 && StrLen(WebSearchAddModifierKey) > 0) {
						Rs := 0
					}Else{
						Rs := -1
					}
				}Else{
					Rs := -1
				}
			}
		}Else{
			Rs := 0
		}
	}Else{
		Rs := -1
	}
Return
;=========================================== 変更ボタンが押せるか判定する
IsEnableWebSearchModifyButton:
	Gui,4: Submit ,NoHide
	If (StrLen(WebSearchMenuText) > 0 && StrLen(WebSearchURL) > 0) {
		If (WebSearchAssignHotkey = 1) {
			If (WebSearchSetByKeyboard == 1) {
				If (StrLen(WebSearchAddHotkey) > 0) {
					Rs := 0
				}Else{
					Rs := -1
				}
			}Else{
				If (WebSearchSelectByMenu == 1) {
					If (StrLen(WebSearchAddkey) > 0 && StrLen(WebSearchAddModifierKey) > 0) {
						Rs := 0
					}Else{
						Rs := -1
					}
				}Else{
					Rs := -1
				}
			}
		}Else{
			Rs := 0
		}
	}Else{
		Rs := -1
	}
Return
;=========================================== クリアボタンが押せるか判定する
IsEnableWebSearchClearButton:
	Gui,4: Submit ,NoHide
	If (StrLen(WebSearchMenuText) > 0 || StrLen(WebSearchURL) > 0  || StrLen(WebSearchSuffix) > 0 || WebSearchMode == 1 || StrLen(WebSearchAddHotkey) > 0 || StrLen(WebSearchAddkey) > 0 || StrLen(WebSearchAddModifierKey) > 0) {
		Rs := 0
	}Else{
		Rs := -1
	}
Return
;=========================================== クリアボタンが押されたときの処理
OnClickWebSearchClearBtn:
	;-------------------------------------- エディットボックスをクリアする
	GuiControl, Text, WebSearchMenuText, 
	GuiControl, Text, WebSearchUrl, 
	GuiControl, Text, WebSearchSuffix, 
	;-------------------------------------- チェックボックスをオフにする
	GuiControl, , WebSearchMode, 0
	GuiControl, , WebSearchAssignHotkey, 0
	;-------------------------------------- ラジオボタンとホットキー登録フォームを操作できないようにする
	GuiControl, Enable0, WebSearchSetByKeyboard
	GuiControl, Enable0, WebSearchSelectByMenu
	GuiControl, Enable0, WebSearchAddHotkey
	GuiControl, Enable0, WebSearchAddkey
	GuiControl, Enable0, WebSearchAddModifierKey
	;-------------------------------------- ラジオボタンと登録フォームの内容をクリアする
	GuiControl, , WebSearchSetByKeyboard, 0
	GuiControl, , WebSearchSelectByMenu, 0
	GuiControl, , WebSearchAddHotkey, 
	GuiControl, , WebSearchAddkey, |%HotkeyAssignDDL%
	GuiControl, , WebSearchAddModifierKey, |%ModifierDDL%
Return
;=========================================== 追加ボタンが押されたときの処理
OnClickWebSearchAddBtn:
	Mode := "Add"
	Gosub SendFormToWebSearchLV
Return
;=========================================== 変更ボタンが押されたときの処理
OnClickWebSearchModifyBtn:
	Mode := "Mod"
	Gosub SendFormToWebSearchLV
Return
;=========================================== 入力フォームの内容をリストビューに転送する
SendFormToWebSearchLV:
	;-------------------------------------- エディットボックスの内容を取得する
	Gui,4: Submit ,NoHide
	;------------------------------------- 表示用の検索モードを取得する
	Key = ModeName%WebSearchMode%
	IniRead, WebSearchModeName, %ConfigFileName%, WEB_SEARCH_MODE, %Key%, -1
	;-------------------------------------- ホットキー保存用の添え字を設定する
	If (Mode == "Add") {
		WebSearchCtr += 1
		ix := WebSearchCtr
	}Else{
		SelectedRow := LV_GetNext(0)
		ix := SelectedRow
	}
	;-------------------------------------- 「ホットキーを割り当てる」チェックボックスがチェックされているときはホットキーを編集する
	If (WebSearchAssignHotkey == 1) {
		If (WebSearchSetByKeyboard == 1) {
			;--------------- 実行用ホットキーを表示用ホットキーに変換する
			Hotkey := DecodeHotkey(WebSearchAddHotkey)
			;-------------------------------------- ホットキーの内容を保存する
			WS_HotkeyKeyboadMem[ix] := WebSearchAddHotkey
			WS_HotkeyMenuModifierMem[ix] := ""
			WS_HotkeyMenuAssignMem[ix] := ""
		}Else{
			If (WebSearchAddModifierKey == HK_ModifierDsp[HotkeyModifierMaxCount] || StrLen(WebSearchAddModifierKey) == 0) {
				;--------------- 修飾キーが指定されてないときはキーだけ登録する
				Hotkey = %WebSearchAddkey%
			}Else{
				Hotkey = %WebSearchAddModifierKey% + %WebSearchAddkey%
			}
			;-------------------------------------- ホットキーの内容を保存する
			WS_HotkeyKeyboadMem[ix] := ""
			WS_HotkeyMenuModifierMem[ix] := WebSearchAddModifierKey
			WS_HotkeyMenuAssignMem[ix] := WebSearchAddkey
		}
	}Else{
		;-------------------------------------- ホットキーの内容を保存する
		WS_HotkeyKeyboadMem[ix] := ""
		WS_HotkeyMenuModifierMem[ix] := ""
		WS_HotkeyMenuAssignMem[ix] := ""
		Hotkey := ""
	}
	If (Mode == "Add") {
		;--------------------------------------リストビューに追加する
		LV_Add("Check1", WebSearchMenuText, Hotkey, WebSearchModeName, WebSearchUrl, WebSearchSuffix)
	}Else{
		;--------------------------------------リストビューを変更する
		LV_Modify(SelectedRow, "Select", WebSearchMenuText, Hotkey, WebSearchModeName, WebSearchUrl, WebSearchSuffix)
	}
	;-------------------------------------- リストビューの列幅を調整する
	LV_ModifyCol(1,"AutoHdr")
	LV_ModifyCol(2,"AutoHdr")
	LV_ModifyCol(3,"AutoHdr")
	;-------------------------------------- 保存ボタンを押せるようにする
	GuiControl, Enable1, WebSearchSaveBtn
Return
;=========================================== WEB検索機能の設定内容を読み込んでリストビューを構築する
BuildWebSearchLV:
	WebSearchCtr := 0
	Mode := 1
	Gosub AddWebSearchLV
	Mode := 0
	Gosub AddWebSearchLV
	;------------------------------------- リストビューの列幅を調整する
	LV_ModifyCol(1,"AutoHdr")
	LV_ModifyCol(2,"AutoHdr")
	LV_ModifyCol(3,"AutoHdr")
	LV_ModifyCol(4,"AutoHdr")
	LV_ModifyCol(5,"AutoHdr")
Return
AddWebSearchLV:
	loop {
		Section = WEB_SEARCH%Mode%_%A_Index%
		IniRead, WebSearchMenuText, %IniFileName%, %Section%, MenuText, -1
		If (WebSearchMenuText == -1) {
			Break
		}
		IniRead, WebSearchUrl, %IniFileName%, %Section%, URL, -1
		IniRead, WebSearchSuffix, %IniFileName%, %Section%, Suffix, -1
		IF (WebSearchSuffix == -1) {
			WebSearchSuffix := ""
		}
		;------------------------------------- 表示用の検索モードを取得する
		IniRead, WebSearchMode, %IniFileName%, %Section%, Mode, -1
		Key = ModeName%WebSearchMode%
		IniRead, WebSearchModeName, %ConfigFileName%, WEB_SEARCH_MODE, %Key%, -1
		;------------------------------------- ホットキーを表示用に変換する（関数は機能設定画面スクリプトで定義）
		IniRead, WebSearchHotkey, %IniFileName%, %Section%, Hotkey, -1
		WebSearchHotkey := DecodeHotkey(WebSearchHotkey)
		;------------------------------------- リストビューに追加する
		LV_Add("Check"Mode, WebSearchMenuText, WebSearchHotkey, WebSearchModeName, WebSearchUrl, WebSearchSuffix)
		;-------------------------------------- 「キーボードからホットキーを入力」を変数に保存する
		WebSearchCtr += 1
		Section = WEB_SEARCH%Mode%_%A_Index%
		IniRead, strWrk, %IniFileName%, %Section%, HotkeyKeyboad, -1
		WS_HotkeyKeyboadMem[WebSearchCtr] := strWrk
		;-------------------------------------- 「メニューからホットキーのキーを選択」を変数に保存する
		IniRead, strWrk, %IniFileName%, %Section%, HotkeyMenuAssign, -1
		WS_HotkeyMenuAssignMem[WebSearchCtr] := strWrk
		;-------------------------------------- 「メニューからホットキーの修飾キーを選択」を変数に保存する
		IniRead, strWrk, %IniFileName%, %Section%, HotkeyMenuModifier, -1
		WS_HotkeyMenuModifierMem[WebSearchCtr] := strWrk
	}
Return
;=========================================== GUI画面を閉じたときの処理
4ConfigClose:
4GuiClose:
	;-------------------------------------- リロード後、設定画面を再表示させるように設定する
	IniWrite,1,%IniFileName%,AUTOEXEC,StartUp
	IniWrite,機能設定,%IniFileName%,AUTOEXEC,ShowConfigPanel
	;-------------------------------------- リロード後の復元情報をクリアする
	IniWrite,0,%IniFileName%,AUTOEXEC,WS_SelectedRow
	;-------------------------------------- リロードして設定を反映させる
	Reload
Return
;=========================================== 再表示時に復元できるようにリストビューの選択状態を保存してリロードする
SaveLastSessionAndReloadWS:
	;------------------- リストビューの選択されている行番号を取得して保存する
	Gui,4:ListView,WebSearchLV
	SelectedRow := LV_GetNext(0)
	IniWrite,%SelectedRow%,%IniFileName%,AUTOEXEC,WS_SelectedRow
	;-------------------------------------- リロード後、設定画面を再表示させるように設定する
	IniWrite,1,%IniFileName%,AUTOEXEC,StartUp
	IniWrite,選択文字でWEB検索機能設定,%IniFileName%,AUTOEXEC,ShowConfigPanel
	;-------------------------------------- リロードして設定を反映させる
	Reload
Return